/* https://github.com/facebook/flux/blob/master/docs/Flux-Utils.md
   Are react components that control a view
   Primary job is to gather information from stores and save it in their state
   Have no props and no UI logic
*/
import LivevideoBrowseContent from '../../views/livevideo/LivevideoBrowseContent';
import {Container} from 'flux/utils';
import LivevideoStore from '../../data/stores/LivevideoStore';
import LivevideoActions from '../../data/actions/LivevideoActions';

function getStores(){
    return [LivevideoStore];
}

function getState(){
    return {
        videos:LivevideoStore.getState(),
        browseVideoByType:LivevideoActions.browseLivevideo,
        fetchNextVideos:LivevideoActions.fetchNext,
        browseVideoGroup:LivevideoActions.browseVideoGroup,
        fetchNextVideoGroup:LivevideoActions.fetchNextVideoGroup,
        browseVideoByCategory:LivevideoActions.browseVideoByCategory,
        fetchNextVideoByCategory:LivevideoActions.fetchNextVideoByCategory,
    };
}

export default Container.createFunctional(LivevideoBrowseContent, getStores, getState );
