/* https://github.com/facebook/flux/blob/master/docs/Flux-Utils.md
   Are react components that control a view
   Primary job is to gather information from stores and save it in their state
   Have no props and no UI logic
*/
import PlayerViewContent from '../../views/livevideo/PlayerViewContent';
import LivevideoStore from '../../data/stores/LivevideoStore';
import LivevideoActions from '../../data/actions/LivevideoActions';
import LikeStore from '../../data/stores/LikeStore';
import ReactionStore from '../../data/stores/ReactionStore';
import {Container} from 'flux/utils';


import CommentActions from '../../data/actions/CommentActions';
import CommentStore from '../../data/stores/CommentStore';

function getStores(){
    return [LivevideoStore,LikeStore,ReactionStore,CommentStore];
}

function getState(){
    return {
        livevideo:LivevideoStore.getState(),
        likes:LikeStore.getState(),
        reactions:ReactionStore.getState(),
        comments:CommentStore.getState(),
        //load:LivevideoActions.load,
        fetchComment:CommentActions.fetchComment,
        checkCommentStatus:CommentActions.checkCommentStatus,
        fetchCommentById:CommentActions.fetchCommentById,
        refreshComments:CommentActions.refeshAndScrollToBottom,
    };
}

export default Container.createFunctional(PlayerViewContent, getStores, getState );
