'use strict';

import LivevideoActionTypes from './LivevideoActionTypes';
import AppDispatcher from '../AppDispatcher';

const Actions = {
    load(data){
        AppDispatcher.dispatch({
            type:LivevideoActionTypes.LOAD_A_LIVEVIDEO,
            data
        });
    },
    setLivevideoDetail(data){
        AppDispatcher.dispatch({
            type:LivevideoActionTypes.SET_LIVEVIDEO_DETAIL,
            data
        });
    },
    browseLivevideoByCategory(id){
        AppDispatcher.dispatch({
            type:LivevideoActionTypes.BROWSE_LIVEVIDEO_BY_CATEGORY,
            id
        });
    },
    browseLivevideo(filter){
        AppDispatcher.dispatch({
            type:LivevideoActionTypes.BROWSE_LIVEVIDEO,
            filter
        });
    },
    fetchLivevideo(data,page){
        AppDispatcher.dispatch({
            type:LivevideoActionTypes.FETCH_LIVEVIDEO,
            data,page
        });
    },
    fetchNext(){
        AppDispatcher.dispatch({
            type:LivevideoActionTypes.FETCH_NEXT_LIVEVIDEO,
        });
    },
    fetchNextLivevideoByCategory(id){
        AppDispatcher.dispatch({
            type:LivevideoActionTypes.FETCH_NEXT_LIVEVIDEO_CATEGORY,
            id
        });
    },
    stopFetch(){
        AppDispatcher.dispatch({
            type:LivevideoActionTypes.STOP_FETCH,
        });
    },
    browseFriendLivevideo(id){
        AppDispatcher.dispatch({
            type:LivevideoActionTypes.FRIEND_LIVEVIDEO,
            id
        });
    },
    fetchNextFriendLivevideo(id){
        AppDispatcher.dispatch({
            type:LivevideoActionTypes.FETCH_NEXT_FRIEND_LIVEVIDEO,
            id
        });
    },
    searchLivevideo(keyword){
        AppDispatcher.dispatch({
            type:LivevideoActionTypes.SEARCH_LIVEVIDEO,
            keyword
        });
    },
    searchNextLivevideo(keyword){
        AppDispatcher.dispatch({
            type:LivevideoActionTypes.SEARCH_NEXT_LIVEVIDEO,
            keyword
        });
    },
};
export default Actions;
