'use strict';


import {ReduceStore} from 'flux/utils';

import LivevideoActionTypes from '../actions/LivevideoActionTypes';
import LivevideoActions from '../actions/LivevideoActions';
import AppDispatcher from '../AppDispatcher';
import Immutable from 'immutable';
import LikeStore from './LikeStore';
import ReactionStore from './ReactionStore';
import AppAction from '../../utility/AppAction';
var isOpen = false;
var isFetching = false;
var endOfPage = false;
var isSearch = false;
var cPage = 1;
var cType = 'all';
function _fetchBlogByCategory(id, page) {
    if(isFetching){
        return false;
    }
    isFetching = true;
    cPage = page;
    if (_.has(mooConfig, "access_token")) {
        var statusCode = 0;
        setTimeout(function () {
            fetch(mooConfig.url.base + '/api/blog/category/' + id + '?page=' + page+'&language='+mooConfig.language, {
                method: 'GET',
                headers: {'moo-access-token': mooConfig.access_token,
                    'page': page,
                    'Content-Type': 'application/json'},

            }).then(function (response) {
                statusCode = response.status;
                isFetching = false;
                return response.json()
            }).then(function (json) {
                if (_.has(json, "errorCode")) {
                    if(_.get(json, "errorCode") == 'token_expired') {
                            AppAction.refreshToken();
                            return 0;
                        }
                    if(page == 1) {
                        if(statusCode == "404") {
                            LivevideoActions.fetchLivevideo(null);
                        }
                    }
                    else {
                        LivevideoActions.stopFetch();
                        endOfPage = true;
                        return 0;
                    }
                }
                LivevideoActions.fetchLivevideo(json,page);
            }).catch(function (ex) {
                isFetching = false;
                console.log('parsing failed', ex)
            })
        }, 100);
    }
}
function _fetchLivevideos(type, page) {
    if(isFetching){
        return false;
    }
    isFetching = true;
    cPage = page;
    if (_.has(mooConfig, "access_token")) {
        if (!type) type = cType;
        var statusCode = 0;
        setTimeout(function () {
            fetch(mooConfig.url.base + '/api/livevideo/' + type + '?page=' + page+'&language='+mooConfig.language, {
                method: 'GET',
                headers: {'moo-access-token': mooConfig.access_token,
                    'page': page,
                    'Content-Type': 'application/json'},

            }).then(function (response) {
                statusCode = response.status;
                isFetching = false;
                return response.json()
            }).then(function (json) {
                if (_.has(json, "errorCode")) {
                    if(_.get(json, "errorCode") == 'token_expired') {
                            AppAction.refreshToken();
                            return 0;
                        }
                    if(page == 1) {
                        if(statusCode == "404") {
                            LivevideoActions.fetchLivevideo(null);
                        }
                    }
                    else {
                        LivevideoActions.stopFetch();
                        endOfPage = true;
                        return 0;
                    }
                }
                LivevideoActions.fetchLivevideo(json,page);
            }).catch(function (ex) {
                isFetching = false;
                console.log('parsing failed', ex)
                console.log(mooConfig.url.base + '/api/livevideo/' + type + '?page=' + page+'&language='+mooConfig.language);
            })
        }, 100);
    }
}
function _fetchFriendBlogs(id, page) {
    if(isFetching){
        return false;
    }
    isFetching = true;
    cPage = page;
    if (_.has(mooConfig, "access_token")) {
        var statusCode = 0;
        setTimeout(function () {
            fetch(mooConfig.url.base + '/api/user/' + id + '/blogs?page=' + page+'&language='+mooConfig.language, {
                method: 'GET',
                headers: {'moo-access-token': mooConfig.access_token,
                    'page': page,
                    'Content-Type': 'application/json'},

            }).then(function (response) {
                statusCode = response.status;
                isFetching = false;
                return response.json()
            }).then(function (json) {
                if (_.has(json, "errorCode")) {
                    if(_.get(json, "errorCode") == 'token_expired') {
                            AppAction.refreshToken();
                            return 0;
                        }
                    if(page == 1) {
                        if(statusCode == "404") {
                            LivevideoActions.fetchLivevideo(null);
                        }
                    }
                    else {
                        LivevideoActions.stopFetch();
                        endOfPage = true;
                        return 0;
                    }
                }
                LivevideoActions.fetchLivevideo(json,page);
            }).catch(function (ex) {
                isFetching = false;
                console.log('parsing failed', ex)
            })
        }, 1100);
    }
}
function _loadData(data) {
    setTimeout(function () {
        LivevideoActions.setLivevideoDetail(data);
    },100);

    return;
    if (_.has(mooConfig, "access_token")) {
        setTimeout(function () {
            fetch(mooConfig.url.base + '/api/livevideo/' + id+'?language='+mooConfig.language, {
                method: 'GET',
                headers: {'moo-access-token': mooConfig.access_token,
                    'Content-Type': 'application/json'},

            }).then(function (response) {
                return response.json()
            }).then(function (json) {
                if (_.has(json, "errorCode")) {
                    if(_.get(json, "errorCode") == 'token_expired') {
                            AppAction.refreshToken();
                            return 0;
                        }
                    return 0;
                }
                LivevideoActions.fetchLivevideoDetail(json);
            }).catch(function (ex) {
                console.log('parsing failed', ex)
            })
        }, 100);
    }
}
function _searchVideo(keyword,page) {
    if(isFetching){
        return false;
    }
    isFetching = true;
    cPage = page;
    if (_.has(mooConfig, "access_token")) {
        var statusCode = 0;
        setTimeout(function () {
            fetch(mooConfig.url.base + '/api/livevideo/filter'+'?page=' + page+'&language='+mooConfig.language , {
                method: 'POST',
                headers: { 'moo-access-token': mooConfig.access_token ,
                          'Content-Type': 'application/json'} ,
                body: JSON.stringify({keyword:keyword})

            }).then(function (response) {
                statusCode = response.status;
                isFetching = false;
                return response.json()
            }).then(function (json) {
                if (_.has(json, "errorCode")) {
                    if(_.get(json, "errorCode") == 'token_expired') {
                            AppAction.refreshToken();
                            return 0;
                        }
                    if(page == 1) {
                        if(statusCode == "404") {
                            LivevideoActions.fetchLivevideo(null);
                        }
                    }
                    else {
                        LivevideoActions.stopFetch();
                        endOfPage = true;
                        return 0;
                    }
                }
                else {
                    LivevideoActions.fetchLivevideo(json,page);
                }
            }).catch(function (ex) {
                isFetching = false;
                console.log('parsing failed', ex)
            })
        }, 100);
    }
}
class LivevideoStore extends ReduceStore {
    constructor() {
        super(AppDispatcher);
    }
    getInitialState() {
        return Immutable.Map({isFetching: isFetching, isOpen: false, livevideos: Immutable.OrderedMap()});
    }
    reduce(state, action) {
        var livevideos = state.get('livevideos');
        state = state.set('isFetching', isFetching);
        switch (action.type) {
            case LivevideoActionTypes.SEARCH_LIVEVIDEO:
                _searchVideo(action.keyword,1);
                isSearch = true;
                return state;
            case LivevideoActionTypes.SEARCH_NEXT_LIVEVIDEO:
                if (!endOfPage) {
                    _searchVideo(action.keyword, cPage + 1);
                }
                state = state.set('livevideos' ,livevideos);
                return state;
            case LivevideoActionTypes.LOAD_A_LIVEVIDEO:
                _loadData(action.data);
                return state;
            case LivevideoActionTypes.SET_LIVEVIDEO_DETAIL:
                LikeStore.set({
                    id: _.get(action.data, 'id', 0),
                    type: _.get(action.data, 'type', ''),
                    like: _.get(action.data, 'likeCount', 0),
                    dislike: _.get(action.data, 'dislikeCount', 0),
                    isViewerLiked: _.get(action.data, 'isViewerLiked', false),
                    isViewerDisliked: _.get(action.data, 'isViewerDisliked', false),
                });

                ReactionStore.set({
                    id: _.get(action.data, 'id', 0),
                    objectType: _.get(action.data, 'type', ''),
                    isPluginActive: _.get(action.data,'reaction.isPluginActive', 0),
                    countAll: _.get(action.data,'reaction.countAll', 0),
                    isViewerReactionType:_.get(action.data,'reaction.currentType', -1),
                    isViewerReactionLabel:_.get(action.data,'reaction.currentTypeLabel',''),
                    isViewerLiked: _.get(action.data,'reaction.isLike', 0),
                    limitReview: _.get(action.data,'reaction.limitReview', 3),
                    priorityReView: _.get(action.data,'reaction.priorityReView', []),
                    typeList: _.get(action.data,'reaction.typeList', {})
                });
                state = state.set('isOpen', true);
                state = state.set('livevideos', action.data);
                return state;

            case LivevideoActionTypes.BROWSE_LIVEVIDEO_BY_CATEGORY:
                _fetchBlogByCategory(action.id, 1);
                return state;
            case LivevideoActionTypes.FETCH_NEXT_LIVEVIDEO_CATEGORY:
                if (!endOfPage) {
                    _fetchBlogByCategory(action.id, cPage + 1);
                }
                state = state.set('livevideos' ,livevideos);
                return state;
            case LivevideoActionTypes.BROWSE_LIVEVIDEO:
                cType = action.filter;
                _fetchLivevideos(action.filter, 1);
                return state;
            case LivevideoActionTypes.FETCH_NEXT_LIVEVIDEO:
                if (!endOfPage) {
                    _fetchLivevideos(action.filter, cPage + 1);
                }
                state = state.set('livevideos' ,livevideos);
                return state;
            case LivevideoActionTypes.STOP_FETCH:
                isFetching = false;
                state = state.set('isFetching', isFetching);
                return state;
            case LivevideoActionTypes.FETCH_LIVEVIDEO:
                state = state.set('isOpen', true);
                if(action.page == 1) {
                    livevideos = livevideos.clear();
                    endOfPage = false;
                }
                if(isSearch == true) {
                    livevideos = livevideos.clear();
                    isSearch = false;
                }
                if (action.data != null) {
                    if (livevideos.size == 0) {
                            // It means this is first loading so we make a trick here
                            var i = 0;
                            while (i < action.data.length) {
                                livevideos = livevideos.set(action.data[i].id, action.data[i]);
                                i++;
                            }

                    } else {
                            for (var i = 0; i < action.data.length; i++) {
                                livevideos = livevideos.set(action.data[i].id, action.data[i]);
                            }
                    }
                }
                console.log("set livevideos",livevideos.count())
                state = state.set('livevideos', livevideos);
                return state;
                case LivevideoActionTypes.FRIEND_LIVEVIDEO:
                    _fetchFriendBlogs(action.id, 1);
                    return state;
                case LivevideoActionTypes.FETCH_NEXT_FRIEND_LIVEVIDEO:
                    if (!endOfPage) {
                        _fetchFriendBlogs(action.id, cPage + 1);
                    }
                    state = state.set('livevideos' ,livevideos);
                return state;
            default:
                return state;
        }
    }
}
export default new LivevideoStore();
