import React from 'react';

import {Card} from 'material-ui/Card';

import AppAction from '../../utility/AppAction';
import AndroidAction from '../../utility/AndroidAction';
import RaisedButton from 'material-ui/RaisedButton';
import {pharse} from '../../utility/mooApp';
import Avatar from 'material-ui/Avatar';
import MuiThemeProvider from 'material-ui/styles/MuiThemeProvider';
import IconButton from 'material-ui/IconButton';
import ImageEdit from 'material-ui/svg-icons/image/edit';
import ImagePhotoCamera from 'material-ui/svg-icons/image/photo-camera';
import ImageImage from 'material-ui/svg-icons/image/image';
import VideoCame from '@material-ui/icons/Videocam';
import SocialPersonAdd from 'material-ui/svg-icons/social/person-add';
import EditorInsertLink from 'material-ui/svg-icons/editor/insert-link';
import NavigationMoreHoriz from 'material-ui/svg-icons/navigation/more-horiz';
import AddCircleOutlineIcon from 'material-ui/svg-icons/content/add-circle-outline';

import {isIOS} from "../../utility/MobileDetector";

export default  class ACForm extends React.Component {
    constructor(props) {
        super(props);

        // This binding is necessary to make `this` work in the callback
        this.handleClick = this.handleClick.bind(this);
    }

    handleClick(postType) {
        var url;
        if(postType) {
            
            if(postType == '#plugin') {
                var id = _.get(this.props, "target_id");
                switch (_.get(this.props, 'type')) {
                    case "User":
                        if ( id != 0 ) {
                            url = mooConfig.url.base + '/activities/ajax_load_feed_form/user/' + id + '?access_token='+mooConfig.access_token;
                        }
                        else
                            url = mooConfig.url.base + '/activities/ajax_load_feed_form/home?access_token='+mooConfig.access_token;
                        break;
                    case "Group_Group" :
                        url = mooConfig.url.base + '/activities/ajax_load_feed_form/group/' + id + '?access_token='+mooConfig.access_token;
                        break;
                    case "Event_Event" :
                        url = mooConfig.url.base + '/activities/ajax_load_feed_form/event/' + id + '?access_token='+mooConfig.access_token;
                        break;
                }
                window.location.href = url;
            }
            else {
                var data = new Array();
                if (_.has(this.props, "target_id")) {
                    data['target_id'] = _.get(this.props, 'target_id');
                    data['type'] = _.get(this.props, 'type');
                }
                data['postType'] = postType;
                AppAction.openPostFeed(data);
            }
        }
    }

    render() {
        if (window.mooapp_hide_what_new)
        {
            return <div className="button_add_feed"><AddCircleOutlineIcon onClick={() => this.handleClick('#plugin')} color="#3878de" ></AddCircleOutlineIcon></div>;
        }
        var users = this.props.users.get("userMe");
        var feedAction = {
            display: "flex", margin: "0", background: "#fff", borderTop: "1px solid #dadde1"
        };
        var formStyle,avatarStyle,shareButton,photoButton,tagButton,imageButton,linkButton,formContent,liveButton;
        
        if(mooConfig.rtl){
            formStyle = {fontSize:"18px",color:"#999",padding:"10px 8px",textTransform:"none",textAlign:"right",display: "block"};
            avatarStyle = {background:"none",borderRadius:0,marginLeft:"10px",verticalAlign:"middle"};
        }
        else {
            formStyle = {fontSize:"18px",color:"#999",padding:"10px 8px",textTransform:"none",textAlign:"left",display: "block"};
            avatarStyle = {background:"none",borderRadius:0,marginRight:"10px",verticalAlign:"middle"};
        }
        
        var avatar = <Avatar style={avatarStyle} size={40} src={_.get(users,'avatar.50_square','')} />;
        shareButton = <MuiThemeProvider>
            <span  style={{height: "35px", padding: "0 0", textAlign: "center", flex: "1"}}>
                <IconButton disableTouchRipple={true} style={{height: "35px", padding: "0"}} ><ImageEdit onClick={() => this.handleClick('#post')} color="#835a5a" ></ImageEdit></IconButton>
            </span>
            </MuiThemeProvider>;
        photoButton = <MuiThemeProvider>
            <span  style={{height: "35px", padding: "0 0", textAlign: "center", flex: "1"}}>
                <IconButton disableTouchRipple={true} style={{height: "35px", padding: "0"}} ><ImagePhotoCamera onClick={() => this.handleClick('#camera')} color="#417505" ></ImagePhotoCamera></IconButton>
            </span>
            </MuiThemeProvider>;
        tagButton = <MuiThemeProvider>
            <span  style={{height: "35px", padding: "0 0", textAlign: "center", flex: "1"}}>
                <IconButton disableTouchRipple={true} style={{height: "35px", padding: "0"}} ><SocialPersonAdd onClick={() => this.handleClick('#tag')} color="#4a90e2" ></SocialPersonAdd></IconButton>
            </span>
            </MuiThemeProvider>;
        imageButton = <MuiThemeProvider>
            <span  style={{height: "35px", padding: "0 0", textAlign: "center", flex: "1"}}>
                <IconButton disableTouchRipple={true} style={{height: "35px", padding: "0"}} ><ImageImage onClick={() => this.handleClick('#image')} color="#f5a623" ></ImageImage></IconButton>
            </span>
            </MuiThemeProvider>;
        if(window.show_more_button == true) {
            linkButton = <MuiThemeProvider>
                <span  style={{height: "35px", padding: "0 0", textAlign: "center", flex: "1"}}>
                    <IconButton disableTouchRipple={true} style={{height: "35px", padding: "0"}} ><NavigationMoreHoriz onClick={() => this.handleClick('#plugin')} color="#78363e" ></NavigationMoreHoriz></IconButton>
                </span>
                </MuiThemeProvider>;
        }

        // Supports live button
        console.log("window.show_live_button",window.show_live_button)
        if(window.show_live_button == true) {
            liveButton = <MuiThemeProvider>
                <span  style={{height: "35px", padding: "0 0", textAlign: "center", flex: "1"}}>
                    <IconButton disableTouchRipple={true} style={{height: "35px", padding: "0"}} >
                        <VideoCame onClick={() => this.handleClick('#live')} color="secondary" ></VideoCame>
                    </IconButton>
                </span>
            </MuiThemeProvider>;
        }

            var labelForm = <div>{avatar}{pharse('newFeedPlaceholder')}</div>
            
            
            
            if(isIOS()){
                formContent = <RaisedButton onClick={() => this.handleClick('#post')} fullWidth={true} label={labelForm} style={{boxShadow:"none"}} overlayStyle={{height:"auto",boxShadow:"none"}} buttonStyle={{height:"auto",boxShadow:"none"}} labelStyle={formStyle} />
            }
            else {
                formContent = <RaisedButton onClick={() => this.handleClick('#post')} fullWidth={true} disableTouchRipple={true} label={labelForm} style={{boxShadow:"none"}} overlayStyle={{height:"auto",boxShadow:"none"}} buttonStyle={{height:"auto",boxShadow:"none"}} labelStyle={formStyle} />
            }
            
            return <Card containerStyle={{padding:"0",boxShadow:"none"}}  >
            {formContent}
            <div style={feedAction}>
                {shareButton}
                {photoButton}
                {tagButton}
                {imageButton}
                {liveButton}
                {linkButton}
            </div>
        </Card>
    }
}
