import React from 'react';
import {Card, CardActions, CardHeader, CardMedia, CardTitle, CardText} from 'material-ui/Card';
import _ from 'lodash';
import {List, ListItem} from 'material-ui/List';
import IconButton from 'material-ui/IconButton';
import ActionMore from 'material-ui/svg-icons/navigation/expand-more';



import {GridList, GridTile} from 'material-ui/GridList';
import Avatar from 'material-ui/Avatar';
import {ACDefault,ACDefaultMedia} from './ACDefault';
import {ACMedia,ACMediaPhone} from './ACMedia';
import {ACWallPost,ACPostLink,ACFriendAdd} from './ACPost';
//-- custom
import {ACVideo,ACVideoShare,ACVideoActivity,ACVideoSocialActivity} from './ACVideo';
//-- end
import {ACGroupJoin} from './ACGroupJoin';
import {ACEvent,ACEventShare,ACEventAttend} from './ACEvent';
import {ACAlbumDetailShare,ACPhoto, ACPhotoComment ,ACPhotoTag} from './ACPhoto';
import {ACCheckinLocation} from './plugin/ACCheckinLocation';
import {ACReviewWrite} from './plugin/ACReviewWrite';
import {ACLive,ACLiveShare} from './plugin/ACLive';
import {FeaturedProductFeed} from './plugin/FeaturedProductFeed';

class ACShareActivity extends React.Component {
    render() {
        return <div>
        <CardText style={{padding:"8px"}} >
            <CardText style={{fontSize:"14px",margin:"0 0 10px 0",padding:"0 0px"}} dangerouslySetInnerHTML={{__html: _.unescape(_.get(this.props, 'objects.contentHtml',''))}} ></CardText>
                    <Card>
                    <CardHeader
                        title={<div  dangerouslySetInnerHTML={{__html: _.unescape(_.get(this.props.objects,'titleHtml',''))}}></div>}
                        subtitle={_.get(this.props.objects,'publishedTranslated','')}
                        avatar={<Avatar src={_.get(this.props, 'objects.actor.image.50_square','')} style={{float:'left',display:'block',borderRadius: 0}} />}
                        textStyle={{display:'block',overflow:'hidden',paddingRight:'0'}}
                    />
                    <ActivityItemContentView {...this.props.objects} isPhone={this.props.isPhone} isShare={true} />

                                        </Card>
            
        </CardText>
        </div>
       ;
    }
}
class ACShareItem extends React.Component {
    render() {
        //if(_.get(this.props,"isPhone",false)==true){
            return <div><CardText ><CardText style={{fontSize:"14px",margin:"0 0 10px 0",padding:"0"}}  dangerouslySetInnerHTML={{__html: _.get(this.props.objects, 'contentHtml','')}}   ></CardText> <Card><ACMediaPhone {...this.props}/></Card></CardText></div>;
        //}else{
        //    var props={};
        //    props['key'] = _.get(this.props,'id',0);
        //    props['primaryText']= _.get(this.props,'objects.title','');
        //    props['secondaryText']=_.get(this.props,'objects.description','');
        //    props['url'] = _.get(this.props,"objects.url",'');
        //    if(_.has(this.props,"objects.images.850")){
        //        props['image'] = _.get(this.props,"objects.images.850");
        //    }

        //    return <div><CardText >{_.get(this.props,'objects.contentHtml','')} </CardText><ACMedia {...props} /></div>;
        //}
        ;
    }
}


class ACAttend extends React.Component {
    render() {
        var items = [];
        this.props.objects.event.forEach(function (item) {
            items.push(<ACMediaFormat key={'ac'+item.id} primaryText={item.title} secondaryText={item.timeTranslated} id={item.id} image={item.image} url={item.url}/>);
        });
        return <div>{items}</div>;
    }
}
// common format
class ACMediaFormat extends React.Component {
    constructor(props) {
        super(props);

        // This binding is necessary to make `this` work in the callback
        this.handleClick = this.handleClick.bind(this);
    }
    handleClick() {
        if(this.props.hasOwnProperty('url')){
            window.location.href = this.props.url;
        }

    }
    render() {
        var primaryText,secondaryText,image,id;
        id = (this.props.hasOwnProperty('id'))? this.props.id:0;
        primaryText = (this.props.hasOwnProperty('primaryText'))? this.props.primaryText:'';
        secondaryText = (this.props.hasOwnProperty('secondaryText'))? this.props.secondaryText:'';
        image = (this.props.hasOwnProperty('image'))? this.props.image:'';
        return <div style={{border: "1px solid rgb(217, 217, 217)",margin:"0 5px 0 5px"}}><List >
            <ListItem key={id}
                      primaryText={_.truncate(primaryText)}
                      secondaryText={<div dangerouslySetInnerHTML={{__html: secondaryText}}></div>}
                      leftAvatar={<Avatar style={{borderRadius: 0}} size={50} src={image} />}
                      secondaryTextLines={2}
                      onClick={this.handleClick}
            />
        </List></div>;
    }
}
// end common format
const components = {
    wall_post:ACWallPost,
    wall_post_link:ACPostLink,
    video_create:ACVideo,
    video_item_detail_share:ACVideoShare,
    photos_add:ACWallPost,
    event_create:ACEvent,
    event_item_detail_share:ACEventShare,
    album_item_detail_share:ACAlbumDetailShare,
    photo_item_detail_share:ACPhoto,
    photos_tag:ACPhotoTag,
    comment_add_photo:ACPhotoComment,
    video_activity:ACVideoActivity,
//-- custom
video_social: ACVideoSocialActivity,
//-- end
    checkin_location:ACCheckinLocation,
    review_write:ACReviewWrite,
    featured_product_feed:FeaturedProductFeed,
    live_create:ACLive,
    live_item_detail_share:ACLiveShare,
    live_create_share:ACLiveShare,
};

export default class ActivityItemContentView extends React.Component {
    render() {
        var action = _.get(this.props,'action','');
        var MyContentType = _.get(components,action,ACDefault);
        if(action != 'video_create' && action != 'video_item_detail_share' && action != 'event_create' && action != 'event_item_detail_share' && action != 'album_item_detail_share' && action != 'photo_item_detail_share'){
            if(_.includes(_.get(this.props,'action','')+"-end", '_share-end')){
                MyContentType = _.includes(action+"-end", '_item_detail_share-end')?ACShareItem:ACShareActivity;
            }
            if(_.includes(action+"-end", '_create-end')){
                MyContentType = ACDefaultMedia;
            }
        }
        if(action == 'group_join'){ 
            MyContentType = ACGroupJoin;
        }
       
        if(action == 'event_attend'){ 
            MyContentType = ACEventAttend;
        }
        if(action == 'friend_add'){ 
            MyContentType = ACFriendAdd;
        }

        if (action == 'live_create'){
            MyContentType = ACLive;
        }
        // By passing the ACShareItem rule
        if(action == 'live_item_detail_share' || action == 'live_item_detail_share'){
            MyContentType = _.get(components,action,ACShareItem);
            console.log("MyContentType live_item_detail_share",MyContentType)
        }

        
        return <MyContentType  {...this.props}/>;
    }
}
