import React from 'react';
import _ from 'lodash';
import {Card, CardActions, CardHeader, CardMedia, CardTitle, CardText} from 'material-ui/Card';
import IconButton from '@material-ui/core/IconButton';
import PlayArrowIcon from '@material-ui/icons/PlayArrow';
import {List, ListItem} from 'material-ui/List';
import Avatar from 'material-ui/Avatar';
import {GridList, GridTile} from "material-ui/GridList";
import {isAndroid} from "../../../utility/MobileDetector";
import AndroidAction from "../../../utility/AndroidAction";
import {ACVideo} from "../ACVideo";


export  class ACLiveIgnore extends React.Component {
    constructor(props) {
        super(props);

        // This binding is necessary to make `this` work in the callback
        this.handleClick = this.handleClick.bind(this);
    }
    handleClick() {
        if(_.has(this.props,'url')){
            window.location.href = this.props.url;
        }
    }
    render() {
        var props={};
        props['key'] = _.get(this.props,'id',0);
        props['primaryText']=<div dangerouslySetInnerHTML={{__html: _.truncate(_.get(this.props,'primaryText',''),{ 'length': 155 })}}></div>;
        props['secondaryText']=<div dangerouslySetInnerHTML={{__html: _.truncate(_.get(this.props,'secondaryText',''),{ 'length': 455 })}}></div>;
        props['secondaryTextLines']=2;
        props['onClick']=this.handleClick;

        if(_.has(this.props,'image')){
            props['leftAvatar'] = <Avatar style={{borderRadius: 0}} size={50} src={_.get(this.props,'image','')} />;
        }
        return <div style={{border: "1px solid rgb(217, 217, 217)",margin:"0 5px 0 5px"}}><List ><ListItem {...props}></ListItem></List></div>
    }
}
export  class ACLive extends React.Component {
    constructor(props) {
        super(props);
        this.handleClick = this.handleClick.bind(this);
    }

    handleClick() {

        if (_.has(this.props, 'objects.url')) {
            let link = this.props.objects.url+'?access_token='+mooConfig.access_token;
            console.log(link);
            if (isAndroid()){
                AndroidAction.openLink(link);
            }else{
                window.location.href = link;
            }

        }
    }

    render() {
        var media, title, desc, duration, live;
        media = title = desc = <div></div>;

        if (_.has(this.props, "objects.title")) {
            title = <CardText style={{padding:"10px",color:"#247BBA",fontSize:'16px',fontWeight:"bold",lineHeight:"20px", wordBreak: "break-word"}} dangerouslySetInnerHTML={{__html: _.unescape(this.props.objects.title)}}></CardText>;
        }
        if (_.has(this.props, "objects.description")) {
            desc = <CardText className="browseDes" style={{padding:"0 10px 10px ",fontSize:"15px",lineHeight:"1.5",wordBreak:"break-word"}} dangerouslySetInnerHTML={{__html: _.get(this.props,'objects.description','')}}  ></CardText>;
        }
        if (_.has(this.props, "objects.images.850")) {
            var img = _.get(this.props,'objects.images.850');
            //var img = "https://i1-giadinh.vnecdn.net/2021/01/12/anh-3789-1610426294.jpg?w=680&h=0&q=100&dpr=2&fit=crop&s=j8226AHMiHJMpmF97qg3_Q";
            duration = null;
            live = null;
            var playStyle = {height: 38,width: 38 };
            if (this.props.livevideo && this.props.livevideo.raw){
                //if (this.props.livevideo.raw ){
                    if (this.props.livevideo.raw.live){
                        console.log(this.props.livevideo.raw.live);
                        playStyle = this.props.livevideo.raw.live ? {height: 38,width: 38 , color:'red'} : {height: 38,width: 38 }
                        live = <CardText style={{position: 'absolute', top:'5px', left:'5px',padding:"5px 10px",color:"#ffffff",fontSize:'16px',fontWeight:"bold",lineHeight:"20px", backgroundColor:"#ff0000", borderRadius:"5px"}} dangerouslySetInnerHTML={{__html: 'Live'}}></CardText>;
                    }
                //}

                if (this.props.livevideo.raw.duration != ''){
                    duration = <CardText style={{position: 'absolute', bottom:'0', right:'0', padding:"3px 10px",color:"#ffffff", backgroundColor: 'rgba(0,0,0,0.5)',fontSize:'16px',fontWeight:"bold",lineHeight:"20px", borderTopLeftRadius: '5px'}} dangerouslySetInnerHTML={{__html: _.unescape(this.props.livevideo.raw.duration)}}></CardText>;
                }
            }

            media = <CardMedia>
                            <div style={{textAlign:'center',width:'100%'}}>
                                <div style={{
                                    backgroundImage:"url('"+img+"')",
                                    backgroundRepeat:"no-repeat",
                                    paddingBottom:"56.25%",
                                    display:"block",
                                    backgroundSize:"cover",
                                    justifyContent: 'center',
                                    backgroundPosition:"center center"}}>




                                </div>
                                <div style={{
                                    position: 'absolute',
                                    top:'40%',
                                    left:'41%'
                                }}>
                                    <IconButton aria-label="Play/pause" style={{backgroundColor:'white'}} >
                                        <PlayArrowIcon style={playStyle} />
                                    </IconButton>
                                </div>
                                {duration}
                                {live}
                            </div>
                        </CardMedia>;
        }
        if (_.has(this.props, "isShare") && _.get(this.props, "isShare") == true ) {
            return <div onClick={this.handleClick}>
                {media}
                {title}
                {desc}
            </div>;
        }
        else {
            return <div style={{padding:"8px"}} ><Card onClick={this.handleClick}>
            {media}
            {title}
            {desc}
            </Card></div>;
        }
    }
}

export class ACLiveShare extends React.Component {
    render() {

        return <div>
            <CardText >
                <CardText style={{fontSize:"14px",margin:"0 0 10px 0",padding:"0 0px"}} dangerouslySetInnerHTML={{__html: _.get(this.props, 'objects.contentHtml','')}}></CardText>
                <Card><ACLive isShare={true} {...this.props}/></Card>

            </CardText>
        </div>;

    }
}
