import _ from 'lodash';
import React from 'react';

import Slider from "react-slick";
import ReactStars from 'react-stars'
import {Card, CardActions, CardHeader, CardMedia, CardTitle, CardText} from 'material-ui/Card';

export class FeaturedProductFeed extends React.Component {
   
    constructor(props) {
        super(props);
    }
    
    render() {
       
        
        var settings = {}
        var sliderWrap = [];
        var sliderContent = [];

        if(_.has(this.props,'objects.products')) {


            // Add slide feature product feed

            var infinite = true;
            if ( this.props.objects.products.length < 3) {
                infinite = false;
            }
            settings = {
              dots: false,
              arrows: false,
              infinite: false,
              swipeToSlide: false,
              autoplay: true,
              autoplaySpeed: 6000,
              speed: 300,
              slidesToShow: 2,
              slidesToScroll: 2
            };

            this.props.objects.products.forEach(function(item, key){
                let oldPriceContent = '';
                let featuredContent = '';
                let discountContent = '';
                if (item.allow_promotion) {
                    oldPriceContent = <div className="store-old-price">{item.old_price}</div>;
                    discountContent = <div className="store-discount">
                        <div className="store-discount-item">
                            <div className="store-discount-content">
                                <span className="store-discount-percent">-{item.sale_percent}%</span>
                            </div>
                        </div>
                    </div>
                }
                if(item.featured){
                    featuredContent = <div className="store-featured">
                        <div className="store-featured-item">
                            <span>Featured</span>
                        </div>
                    </div>
                }

                sliderContent.push(<CardMedia key={Math.random()}>
                    <div className="store-product-item">
                        <div className="store-product-figure">
                            <div className="store-product-image">
                                <a href={item.moo_href}>
                                    {featuredContent}
                                    {discountContent}
                                    <img src={item.image} />
                                </a>
                            </div>
                        </div>
                        <div className="store-product-info">
                            <div className="store-product-name"><a href={item.moo_href}>{item.name}</a></div>
                            <div className="store-review-star">
                                <ReactStars count={5} value={parseInt(item.rating)} size={19} color2={'#F5A623'} className="store-rating-item" edit={false} >
                                </ReactStars>
                            </div>
                            <div className="store-price-box">
                                <div className="store-new-price">{item.new_price}</div>
                                {oldPriceContent}
                            </div>
                        </div>
                    </div>

                </CardMedia>);
            });

            sliderWrap = <Card style={{boxShadow:"none"}} key={Math.random()}>
                <div style={{overflow: '-webkit-paged-x', marginBottom: '8px'}} className="slide-feature-product">
                    <Slider {...settings}>
                        {sliderContent}
                    </Slider>
                </div>
            </Card>;
        }

        return <div>{sliderWrap}</div>;
    }
}
