import React from 'react';
import _ from 'lodash';
import {Card, CardActions, CardHeader, CardMedia, CardTitle, CardText} from 'material-ui/Card';
import {GridList, GridTile} from 'material-ui/GridList';
import MuiThemeProvider from 'material-ui/styles/MuiThemeProvider';
import getMuiTheme from 'material-ui/styles/getMuiTheme';
import {List, ListItem} from 'material-ui/List';
import Avatar from 'material-ui/Avatar';
import {pharse} from '../../utility/mooApp';
import {initLoadMoreBehavior} from '../../utility/mooApp';
import {LoadMore} from '../utility/LoadMoreContent';
import RaisedButton from 'material-ui/RaisedButton';
import {isIOS} from "../../utility/MobileDetector";
import {FirstLoading} from "../utility/FirstLoading";

import FloatingActionButton from 'material-ui/FloatingActionButton';
import ContentAdd from 'material-ui/svg-icons/content/add';
import AppAction from "../../utility/AppAction";


export class VideoList extends React.Component {
    constructor(props) {
        super(props);
        this.handleClick = this.handleClick.bind(this);
        this.handleCreateVideo = this.handleCreateVideo.bind(this);
        this.handleUploadVideo = this.handleUploadVideo.bind(this);
    }
    handleClick(url) {
            window.location.href = url;
    }
    handleCreateVideo() {
        AppAction.openPostFeed({"target_id":"0",type:"User","postType":"#live"});
    }
    handleUploadVideo() {
        if(this.props.groupId) {
            var url = mooConfig.url.base + '/upload_videos/ajax_upload_group/' + this.props.groupId;
        }
        else {
            var url = mooConfig.url.base + '/upload_videos/ajax_upload';
        }

        window.location.href = url;
    }

    render() {
        var avatarStyle,innerDivStyle,content,block,contentVideo,videoList,title,description,media,tmp,isFetching,loadmore,createVideo,uploadVideo;
        uploadVideo = createVideo = loadmore = tmp = media = description = title = videoList = content = <div></div>;
        var videoArray = tmp  = [];

        if(mooConfig.rtl) {
            innerDivStyle = {paddingRight: "60px"};
            avatarStyle = {borderRadius: "0",right:"5px",left:"auto"};
        }
        else {
            innerDivStyle = {paddingLeft: "60px"};
            avatarStyle = {borderRadius: "0",left:"5px"};
        }

        if( this.props.videos.get('isOpen') == true  ) {
            contentVideo = this.props.videos.get('livevideos');
            if (_.has(window, "canCreate")) {
                createVideo = <FloatingActionButton iconStyle={{fill: '#000'}}  backgroundColor="#fff" onClick={() => this.handleCreateVideo()} style={{position:"fixed",bottom:"80px",zIndex:"100",right:"20px"}}>
                        <ContentAdd color="#000" ></ContentAdd>
                                  </FloatingActionButton>;

                /*if (_.has(window, "uploadVideo")) {
                    uploadVideo = <Card containerStyle={{padding:"0",textAlign:"center",marginBottom:"10px"}} onClick={() => this.handleUploadVideo()} >
                                    <RaisedButton fullWidth={true} label={pharse('uploadVideo')} style={{width:"100%"}} overlayStyle={{height:"auto",textAlign:"center"}} buttonStyle={{height:"auto",boxShadow:"none"}} labelStyle={{fontSize:"20px",color:"#000",padding:"10px 16px",textTransform:"none",textAlign:"center",display: "block"}} />
                                </Card>;
                } */
            }

            if(contentVideo.count() > 0) {
                contentVideo.forEach(function(obj) {
                    var duration = null;
                    var live = null;

                    if (_.has(obj, "snapshot")) {
                        var img = _.get(obj, "snapshot");

                        if (_.get(obj, "live")) {
                            live = <CardText style={{position: 'absolute', top: '5px', left: '5px', padding: "5px 10px", color: "#ffffff", fontSize: '16px', fontWeight: "bold", lineHeight: "20px", backgroundColor: "#ff0000", borderRadius: "5px"}} dangerouslySetInnerHTML={{__html: 'Live'}}></CardText>;
                        }else{
                            if (_.get(obj, "duration") != '') {
                                duration = <CardText style={{position: 'absolute', bottom:'0', right:'0', padding:"3px 10px",color:"#ffffff", backgroundColor: 'rgba(0,0,0,0.5)',fontSize:'16px',fontWeight:"bold",lineHeight:"20px", borderTopLeftRadius: '5px'}} dangerouslySetInnerHTML={{__html: _.unescape(_.get(obj, "duration"))}}></CardText>;
                            }
                        }

                        media = <CardMedia>
                            <div style={{textAlign:'center',width:'100%'}}>
                            <div style={{
                                backgroundImage:"url('"+img+"')",
                                backgroundRepeat:"no-repeat",
                                paddingBottom:"56.25%",
                                display:"block",
                                position: 'related',
                                backgroundSize:"cover",
                                justifyContent: 'center',
                                backgroundPosition:"center center"}}>
                            </div>
                            {live}
                            {duration}
                            </div>
                        </CardMedia>;
                    }
                    var userName =  <div style = {{height: "auto", fontSize: "13px", fontWeight: "400",color:"#999",fontFamily:"Roboto, sans-serif"}}>{pharse("postBy")} <div style={{display:"inline-block"}} dangerouslySetInnerHTML={{__html: _.get(obj, 'userName', '')}} ></div> {_.get(obj, "created")}</div>
                    tmp = <Card> <ListItem
                            style={{}}
                            innerDivStyle={innerDivStyle}
                            primaryText={ < div style = {{fontSize: "16px", fontWeight: "700",color:"#247BBA"}}   dangerouslySetInnerHTML={{__html: _.get(obj, 'title', '')}}></div>}
                            secondaryText={userName}
                            leftAvatar={ < Avatar style = {avatarStyle} size={30} src={_.get(obj, 'userAvatar.100_square', '')} />}
                            secondaryTextLines = {2}
                            />
                         </Card>;
                         videoArray.push(<div style={{marginBottom:"10px"}} onClick={() => this.handleClick(_.get(obj,'url',''))} key={obj.id} className="video_browse">{media}{tmp}</div>)

                },this);
                videoList = <div style={{background:"#fff"}} >{uploadVideo}{createVideo}<List>{videoArray}</List></div>;
                isFetching = this.props.videos.get('isFetching') ? true : false ;
                loadmore = <LoadMore isFetching={isFetching} ></LoadMore>;
            }
            else {
                videoList = <div>{uploadVideo}{createVideo}<div style={{background:"#fff",padding:"10px",textAlign:"center",fontFamily:"Roboto, sans-serif"}} >{pharse('notFound')}</div></div>;
            }

        }
        else {
            content = <FirstLoading></FirstLoading>;
        }

        return <MuiThemeProvider ><div>{content}{videoList}{loadmore}</div></MuiThemeProvider>;

    }
}

