import React from 'react';
import _ from 'lodash';
import {Card, CardActions, CardHeader, CardMedia, CardTitle, CardText} from 'material-ui/Card';
import CardContent from '@material-ui/core/CardContent';
import {GridList, GridTile} from 'material-ui/GridList';
import {List, ListItem} from 'material-ui/List';
import MuiThemeProvider from 'material-ui/styles/MuiThemeProvider';
import {pharse} from '../../utility/mooApp';
import {CommentItem} from '../utility/CommentItem.js';
import {DetailActionItem} from '../utility/DetailActionItem';
import CommentActions from '../../data/actions/CommentActions';
import RaisedButton from 'material-ui/RaisedButton';
import {FirstLoading} from "../utility/FirstLoading";

import NavigationMoreVert from 'material-ui/svg-icons/navigation/more-vert';
import IconButton from '@material-ui/core/IconButton';
import Menu from '@material-ui/core/Menu';
import MenuItem from '@material-ui/core/MenuItem';
import MoreVertIcon from '@material-ui/icons/MoreVert';
import MoreHorizIcon from '@material-ui/icons/MoreHoriz';
import Button from '@material-ui/core/Button';
import Typography from '@material-ui/core/Typography';

import {isIOS} from "../../utility/MobileDetector";
import AppAction from '../../utility/AppAction';
import VisibilityIcon from "@material-ui/icons/Visibility";

// Test
import {Player} from '../../../../../../../webroot/livevideo/js/player';

class ViewPlayer extends React.Component {
    constructor(props) {
        super(props);
        this.handleClick = this.handleClick.bind(this);
        this.handleEditDetail = this.handleEditDetail.bind(this);
        this.handleViewAllComment = this.handleViewAllComment.bind(this);
        this.handleClickMenu = this.handleClickMenu.bind(this);
        this.handleClickMoreLiveMenu = this.handleClickMoreLiveMenu.bind(this);
        this.handleCloseMenu = this.handleCloseMenu.bind(this);
        this.state = {
            showViewAllComment:true,
            moreLiveMenu:false,
            anchorEl: null,
        };

        //this.props.load(window.livevideo);

        if(_.has(window,"commentId")) {
            this.props.fetchCommentById(window.commentId,'comment',false);
            if(_.has(window,"replyId") ) {
                this.props.fetchCommentById(window.replyId,'comment',true);
            }
        }
        else {
            this.props.fetchComment( window.liveId,'Livevideo_Livevideo');
        }
        this.props.checkCommentStatus('Livevideo_Livevideo', window.liveId);
    }
    componentDidMount(){
        if(_.has(livevideo,"live") && _.get(livevideo,"live") == true ){
            console.log(window.playerConfig);
            var timeout = 1;
            var me = this;
            if (window.playerConfig === undefined){
                timeout = 100;
            }

            setTimeout(function(){
                var golive = new Player(window.playerConfig);
                golive.initActionButton();
                golive.initWebRTCAdaptor();

                setInterval(function(){
                    console.log("setInterval", me.props.fetchComment,me.props.refreshComments)
                    me.props.refreshComments();
                },1500);
            }, timeout);

        }

    }

    componentDidUpdate(){
        if(_.has(livevideo,"live") && _.get(livevideo,"live") == true ){
            return;
        }
        if(this.props.comments.get("isScrollToBottom")){
            window.scrollTo(0,document.body.scrollHeight);
            setTimeout(function () {
                CommentActions.stopScrollToBottom();
            }, 1);
        }

    }
    handleEditDetail() {
        AppAction.hideComment();
        var url = mooConfig.url.full + mooConfig.url.base + '/live/create/' + window.liveId;
        AppAction.openEditNotNewTab({"link":url});
    }
    handleClick(url) {
            window.location.href = url;
    }
    handleViewAllComment() {
        CommentActions.fetchComment( window.liveId,'Livevideo_Livevideo');
        this.setState({showViewAllComment: !this.state.showViewAllComment});
    }
    handleClickMenu (event) {
        this.setState({ anchorEl: event.currentTarget });
    };
    handleClickMoreLiveMenu (event) {
        this.setState({ moreLiveMenu: !this.state.moreLiveMenu });
    };
    handleCloseMenu () {
        this.setState({ anchorEl: null });
    };
    render() {
        var cmStatus,commentStatus,viewAllComment,content,block,contentBlog,blogView,title,description,media,date,by,canEdit,category,menu,canDelete;
        viewAllComment = canDelete = menu = category = canEdit = by = date = media = description = title = blogView = content = <div></div>;

        if( this.props.livevideo.get('isOpen') == true  ) {
            commentStatus = this.props.comments.get('cmStatus');
            block = commentStatus.forEach(function(obj) {
                    cmStatus = obj;
            }, this);
            var livevideo = this.props.livevideo.get('livevideos');
            if(_.has(livevideo,"live") && _.get(livevideo,"live") == false ){
                media = <video controlsList="nodownload" playsInline={true} width="100%" controls preload="none" poster={_.get(livevideo,"snapshot")}>
                    <source src={_.get(livevideo,"videoSource")} type='video/mp4'/>
                </video>
            }else{
                media = <Card>

                    <div id="live-video">
                        <div  style={{marginLeft:"5px",display: "flex",alignItems: 'center',
                            flexWrap: 'wrap',float:"left",color:"red",position:"absolute"}}><VisibilityIcon   color="error"/><span id="view-count-number">1</span> </div>
                        <video width="100%" id="remoteVideo" autoPlay controls playsInline={true} ></video>
                        <CardActions>
                            <IconButton  onClick={this.handleClickMoreLiveMenu}> <MoreHorizIcon/></IconButton>
                            <Button style={{display:"none"}}  color="primary"  id="start_play_button"> {pharse("start_playing")} </Button>
                            <Button style={{display:"none"}}  id="stop_play_button"> {pharse("stop_playing")} </Button>
                        </CardActions>
                    </div>
                    <div id="message-end-video" style={{display:"none"}}>
                        <CardContent >
                            {pharse("the_live_video_has_ended")}
                        </CardContent>
                    </div>
                    <Button className="btn btn-primary" id="options" style={{display:"none"}}> Options  </Button>
                    <div className="dropdown">
                        <Button style={{display:"none"}} className="btn btn-outline-primary btn-sm dropdown-toggle" type="button"
                                id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true"
                                aria-expanded="false">
                            Force Stream Resolution
                        </Button>
                        <div style={{display:"none"}} id="dropdownMenu" className="dropdown-menu" aria-labelledby="dropdownMenuButton">
                            <a className="dropdown-item active"
                               href="#">Automatic</a>
                        </div>
                    </div>
                </Card>
            }

            if (_.has(window, "canEdit")) {
                canEdit = <MenuItem onClick={() => this.handleEditDetail()} >{pharse("edit")}</MenuItem>
            }
            if (_.has(window, "canDelete")) {
                canDelete = <MenuItem onClick={() => this.handleClick(mooConfig.url.base + '/livevideos/delete/' + window.liveId )}  >{pharse("delete")}</MenuItem>
            }


            const { anchorEl } = this.state;

            menu = <div>
                <Button
                  aria-owns={anchorEl ? 'simple-menu' : undefined}
                  aria-haspopup="true"
                  onClick={this.handleClickMenu}
                  style={{display:"block",position:"absolute",right:"5px",top:"18px",minWidth:"0",padding:"0",minHeight:"30px"}}
                >
                  <MoreVertIcon />
                </Button>
                <Menu
                  id="simple-menu"
                  anchorEl={anchorEl}
                  open={Boolean(anchorEl)}
                  onClose={this.handleCloseMenu}
                >
                    {canEdit}
                    {canDelete}
                    <MenuItem onClick={() => this.handleClick(mooConfig.url.base + '/reports/ajax_create/Livevideo_Livevideo/' + window.liveId )} >{pharse("report")}</MenuItem>
                </Menu>
            </div>

            if (_.has(livevideo, "title")) {
                 var color = _.get(livevideo,"live")? '#FF0000':'#000';
                 title = <div style={{position:"relative"}}>
                    <div style={{padding:"20px 30px 10px 10px",color:color,fontSize:'16px',fontWeight:"bold",lineHeight:"20px"}} dangerouslySetInnerHTML={{__html: livevideo.title}}></div>
                    {menu}
                   </div>
            }
            if (_.has(window, "blogCategory")) {
                category = <div style={{display:"inline-block",margin:"5px 0 5px 5px"}} >{pharse('in')}<div style={{margin:"0 0 0 5px",display:"inline-block",fontSize:'12px',fontWeight:"600"}} >{window.blogCategory}</div></div>;
            }
            if (_.has(livevideo, "publishedTranslated")) {
                by = <div style={{display:"inline-block",margin:"5px"}} >{pharse('by')}<div onClick={() => this.handleClick(_.get(livevideo,'userUrl',''))} style={{margin:"0 5px",display:"inline-block",color:"#247BBA",fontSize:'12px'}} dangerouslySetInnerHTML={{__html: _.unescape(_.get(livevideo, 'userName',''))}} ></div></div>;
                date = <div style={{padding:"10px 10px",fontSize:"12px",color:"#999"}}>{livevideo.publishedTranslated}{category}{by}</div>;
            }
            if (_.has(livevideo, "body")) {
                description = <div className="post-body" style={{padding:"10px 10px 10px ",fontSize:"15px",lineHeight:"1.5"}} dangerouslySetInnerHTML={{__html: livevideo.body}}></div>
            }

            if(_.has(window,"commentId") ) {
                if(this.state.showViewAllComment) {
                    viewAllComment = <div onClick={() => this.handleViewAllComment()} style={{fontFamily:"Roboto, sans-serif",background:"#fff",color: "#247BBA",display: "block", padding: "10px 10px 0", margin: "0", position: "relative"}} >{pharse('viewAllComment')}</div>
                }
            }
            var order = "ASC"; // Dump args
            if(_.has(livevideo,"live") && _.get(livevideo,"live") == true ){
                order = "DESC"
            }
            var card = <Card style={{boxShadow:"none"}} >{media}{title}{date}{description}</Card> ;
            if(_.has(livevideo,"live") && _.get(livevideo,"live") == true ){
                if( this.state.moreLiveMenu == false){
                    card = <Card style={{boxShadow:"none"}} >{media}</Card> ;
                }
            }

            blogView = <div style={{margin:"-8px"}} >
                {card}
                <DetailActionItem {...livevideo} likes={this.props.likes} commentStatus={cmStatus} reactions={this.props.reactions} object={'Livevideo_Livevideo'} />
                {viewAllComment}
                <CommentItem {...this.props} order={order} likes={this.props.likes} commentStatus={cmStatus} reactions={this.props.reactions} object={'Livevideo_Livevideo'} object_id={ window.liveId}  />
            </div>;
        }
        else {
            content = <FirstLoading></FirstLoading>;
        }

        return <MuiThemeProvider ><div>{content}{blogView}</div></MuiThemeProvider>;

    }
}
function LivevideoViewContent(props) {
    return <ViewPlayer {...props} />
}

export default LivevideoViewContent;
