import React from 'react';
import _ from 'lodash';
import MuiThemeProvider from 'material-ui/styles/MuiThemeProvider';
import getMuiTheme from 'material-ui/styles/getMuiTheme';
import {CardMedia} from 'material-ui/Card';
import {GridList, GridTile} from 'material-ui/GridList';

import Avatar from 'material-ui/Avatar';
import {pharse} from '../../utility/mooApp';
import RaisedButton from 'material-ui/RaisedButton';
import UserActions from '../../data/actions/UserActions';


import IconButton from '@material-ui/core/IconButton';
import Menu from '@material-ui/core/Menu';
import MenuItem from '@material-ui/core/MenuItem';
import MoreVertIcon from '@material-ui/icons/MoreVert';
import CloseIcon from '@material-ui/icons/Close';
import Button from '@material-ui/core/Button';

import {FirstLoading} from "../utility/FirstLoading";


import EditorBorderColor from 'material-ui/svg-icons/editor/border-color';
import CommunicationMessage from 'material-ui/svg-icons/communication/message';
import CommunicationRssFeed from 'material-ui/svg-icons/communication/rss-feed';
import SocialGroupAdd from 'material-ui/svg-icons/social/group-add';
import SocialPersonAdd from 'material-ui/svg-icons/social/person-add';
import NavigationCheck from 'material-ui/svg-icons/navigation/check';
import NavigationMoreVert from 'material-ui/svg-icons/navigation/more-vert';
import ImagePhotoCamera from 'material-ui/svg-icons/image/photo-camera';

import ContentClear from 'material-ui/svg-icons/content/clear';

import SocialPersonOutline from 'material-ui/svg-icons/social/person-outline';
import ImageCollections from 'material-ui/svg-icons/image/collections';

import ActivityItem from '../activity/Item';
import {isPhone} from '../../utility/MobileDetector';

import {initLoadMoreBehavior} from '../../utility/mooApp';
import ACForm from '../activity/ACForm';
import {LoadMore} from '../utility/LoadMoreContent';
import AppAction from '../../utility/AppAction';

import LinearProgress from 'material-ui/LinearProgress';
import {CommentItem} from '../utility/CommentItem.js';
import CommentActions from '../../data/actions/CommentActions';
import ImageCameraAlt from 'material-ui/svg-icons/image/camera-alt';
const iconNotActive = getMuiTheme({
    svgIcon: {
        color: "#90949c"
    }
});
class UserView extends React.Component {
    constructor(props) {
        super(props);
        this.handleClick = this.handleClick.bind(this);
    }
    componentWillMount(){
        this.props.viewUserById(window.userId);
        this.props.fetchMe();
        if(window.access == 1) {
            
            if(window.activityId == 0) {
                this.props.getUserActivity(window.userId,1);
                initLoadMoreBehavior(function(){
                        this.props.fetchNextUserActivities(window.userId);
                    }.bind(this));
            }
            else {
                this.props.fetchSingleActivity(window.activityId);
                if(_.has(window,"commentId")) {
                    if(_.has(window,"isPhotoFeed")) {
                        this.props.fetchCommentById(window.commentId,'comment',false);
                    }
                    else {
                        this.props.fetchCommentById(window.commentId,'core_activity_comment',false);
                    }
                    if(_.has(window,"replyId")) {
                        this.props.fetchCommentById(window.replyId,'comment',true);
                    }
                }
                else {
                    if(_.has(window,"idToGetComment") && _.has(window,"typeToGetComment")) {
                        this.props.fetchComment(window.idToGetComment,window.typeToGetComment);
                    }else {
                        this.props.fetchComment(window.activityId, 'Activity');
                    }
                }

                if(_.has(window,"idToGetComment") && _.has(window,"typeToGetComment")) {
                    this.props.checkCommentStatus(window.typeToGetComment,window.idToGetComment);
                } else if(_.has(window,"isPhotoFeed")) {
                    this.props.checkCommentStatus('Photo_Photo',window.photoFeedId);
                }
                else {
                    this.props.checkCommentStatus('Activity',window.activityId);
                }
            }
            
            
            // Hacking for auto hide ios header
            var lastScrollTop = 0;
            var isSendCommandHideNavigationBar = false;
            var isSendCommandShowNavigationBar = true;

            // element should be replaced with the actual target element on which you have applied scroll, use window in case of no target element.
            window.addEventListener("scroll", function(){ // or window.addEventListener("scroll"....
                var st = window.pageYOffset || document.documentElement.scrollTop; // Credits: "https://github.com/qeremy/so/blob/master/so.dom.js#L426"
                if ((window.innerHeight + window.pageYOffset ) >= document.body.offsetHeight  ) {
                    return false;
                }
                //var body = document.getElementsByTagName("body")[0];
                //if(body.style.overflow == "visible") {
                    if (st > lastScrollTop && st > 0  ){
                        AppAction.hideNavigationBar()
                    }
                    if(st < lastScrollTop){
                        AppAction.showNavigationBar()
                    }
                    lastScrollTop = st;
                //}
            }, false);
        }
        
    }
    componentDidUpdate(prevProps, prevState) {
        setTimeout(function () {
            if(prevProps.activites.get('shouldCheck') == true) {
                prevProps.removeActivityByRefesh();
                prevProps.fetchMe();
            }
        }, 1);
        if(this.props.comments.get("isScrollToBottom")){
            window.scrollTo(0,document.body.scrollHeight);
            setTimeout(function () {
                CommentActions.stopScrollToBottom();
            }, 1);
        }
    }
    handleClick(url) {
        window.location.href = url;
    }

    render() {
        var canChangeAvatar,content , cover ,profile,avatar,name,button,info,menu,feed ,profileNamePlugin ,profileCompletion,updatecoverButton ;
        canChangeAvatar = updatecoverButton = profileCompletion = profileNamePlugin = feed = menu = info = button = name = avatar = profile = cover = content = <div></div>;
        if( this.props.users.get('isOpen') == true  ) { 
            var user = this.props.users.get('users');
            //var block = this.props.users.get('users').forEach(function(obj) {
                if(window.activityId == 0) {
                    if (_.has(user, "cover")) {

                        if (_.has(window,"canUpdateCover")) {
                            updatecoverButton = <div onClick={() => this.handleClick(mooConfig.url.base + '/users/ajax_cover')} style={{position:"absolute",right:"5px",top:"5px",background:"rgba(0, 0, 0, 0.6)",borderRadius:"0"}} >
                                <IconButton style={{height: "35px", padding: "0"}} ><ImageCameraAlt style={{color:"rgb(144, 148, 156)"}}></ImageCameraAlt></IconButton>
                            </div>;
                        }
                        cover = <div style={{backgroundImage :"url(" + _.get(user,"cover") + ")",height:"165px",backgroundSize:"cover",display:"Block",backgroundRepeat:"no-repeat",backgroundPosition:"center center",position:"relative"}} >{updatecoverButton}</div>
                    }
                    if (_.has(user, "avatar.200_square")) {  
                        if (_.has(window,"canChangeAvatar")) {
                            canChangeAvatar = <MuiThemeProvider muiTheme={iconNotActive}>
                                <span onClick={() => this.handleClick(mooConfig.url.base + '/users/avatar')}  style={{position:"absolute",right:"5px",top:"5px",background:"rgba(0, 0, 0, 0.6)",borderRadius:"0"}}>
                                    <IconButton style={{height: "35px", padding: "0"}} ><ImageCameraAlt></ImageCameraAlt></IconButton>
                                </span>
                            </MuiThemeProvider>;
                        }
                        if (_.has(window,"isOnline")) {  
                            avatar = <div style={{position:"relative",display:"block",margin:"-85px auto 15px",width:"160px"}}> 
                                    <Avatar style={{borderRadius:"0",padding:"5px",background:"#fafafa"}} size={150} src={_.get(user,'avatar.200_square','')} />
                                    <span className="online-stt"></span>
                                    {canChangeAvatar}
                                    </div>
                        }
                        else {
                            avatar = <div style={{position:"relative",display:"block",margin:"-85px auto 15px",width:"160px"}}> 
                                    <Avatar style={{borderRadius:"0",padding:"5px",background:"#fafafa"}} size={150} src={_.get(user,'avatar.200_square','')} />
                                    {canChangeAvatar}
                                    </div>
                        }
                    }
                    if (_.has(user, "name")) {  
                        name = <div style={{fontFamily:"Roboto, sans-serif",textAlign:"center",display:"block",margin:"10px auto",padding:"0 10px 0 ",color:"#000",fontSize:'16px',fontWeight:"bold",lineHeight:"20px"}} dangerouslySetInnerHTML={{__html: user.name}}></div>
                    }
                    if (_.has(window, "profileNamePlugin")) {  
                        profileNamePlugin = <div style={{fontFamily:"Roboto, sans-serif",textAlign:"center",display:"block",margin:"0 auto",padding:"0 10px 0 ",color:"#000",fontSize:'16px',fontWeight:"bold",lineHeight:"20px"}} dangerouslySetInnerHTML={{__html: window.profileNamePlugin}}></div>
                    }
                    if (_.has(window, "profileCompletion")) {  
                        profileCompletion = <UserProfileCompletion {...this.props} ></UserProfileCompletion>;
                    }
                    button = this.props.users.get(user.id);
                }

                if(user.canView == true) {
                    if(window.activityId == 0) { 
                        info  = <UserProfileInfo {...user} ></UserProfileInfo>;
                        menu = <UserProfileMenu {...this.props} ></UserProfileMenu>;
                    }
                    feed = <UserFeed {...this.props} isPhone={isPhone()} ></UserFeed>;
                }
                else {
                    info  = <div style={{fontFamily:"Roboto, sans-serif",textAlign:"center",display:"block",margin:"0 auto",padding:"20px ",color:"#000"}}>{user.name} {pharse('notAllow')}</div>;
                }
                
                if(window.activityId == 0) { 
                    profile = <div>
                            <div style={{background:"#fff",margin:"-8px -8px 10px"}} >
                                {cover}{avatar}{name}{profileNamePlugin}
                                <UserProfileAction button={button} {...user} ></UserProfileAction>
                                {info}
                            </div>
                            {menu}
                            {profileCompletion}
                            {feed}
                        </div>
                }
                else {
                    profile = <div>{feed}</div>
                }
            //}, this);
        }
        else {
            content = <FirstLoading></FirstLoading>;
        }
        
        return <MuiThemeProvider ><div>{content}{profile}</div></MuiThemeProvider>;

    }
}
class UserProfileAction extends React.Component {
    constructor(props) {
        super(props);
        this.handleClick = this.handleClick.bind(this);
        this.handleChange = this.handleChange.bind(this);
        this.handleRespond = this.handleRespond.bind(this);
        this.handleClickSendMessage = this.handleClickSendMessage.bind(this);
        this.handleActionFollow = this.handleActionFollow.bind(this);
        this.handleClickMenu = this.handleClickMenu.bind(this);
        this.handleCloseMenu = this.handleCloseMenu.bind(this);
        this.handleClickMenu2 = this.handleClickMenu2.bind(this);
        this.handleCloseMenu2 = this.handleCloseMenu2.bind(this);
        this.state = {follow:this.props.follow,anchorEl: null,anchorEl2:null};
    }
    componentWillMount(){
    }
    handleActionFollow() {
      var id = window.userId;
      if(this.state.follow) {
         UserActions.unFollowUser(id);
      }
      else {
         UserActions.followUser(id);
      }
      this.setState({ follow:!this.state.follow });
    }

    handleClickSendMessage(url) {
        if(window.isSendMessageByChatApp) {
            window.require(["mooChat"],function(chat){chat.openChatWithOneUser(window.userId)});
        }
        else {
            window.location.href = url;
        }
    }
    handleClick(url) {
        window.location.href = url;
    }
    handleRespond(id,flag) {
        UserActions.respondRequest(id,flag);
    }
    handleChange(id,action) {
        switch (action) {
            case 1 : 
                UserActions.addFriend(id);
                break;
            case 4 : 
                UserActions.cancelRequest(id);
                break;
            case 2 : 
                UserActions.removeFriend(id);
                break;
        }
    }
    handleClickMenu (event) {
        this.setState({ anchorEl: event.currentTarget });
    };
    handleCloseMenu () {
        this.setState({ anchorEl: null });
    };
    handleClickMenu2 (event) {
        this.setState({ anchorEl2: event.currentTarget });
    };
    handleCloseMenu2 () {
        this.setState({ anchorEl2: null });
    };

    render() {
        var content, editProfile,sendMessage,requestSent,respond,addFriend,follow,moreAction,feature,unFeature,editUser,unFriend,block,unBlock,url,report ;
        unBlock = block = unFriend = editUser = unFeature = feature = moreAction = follow = addFriend = respond = requestSent = sendMessage = editProfile = content = report = <div></div>;
        
        if(window.uid == this.props.id) {
            
            url =  mooConfig.url.base + '/users/profile';
            editProfile = <MuiThemeProvider muiTheme={iconNotActive}>
                <span onClick={() => this.handleClick(url)}  style={{height: "60px", padding: "10px 0", textAlign: "center", flex: "1"}}>
                    <IconButton style={{height: "35px", padding: "0"}} ><EditorBorderColor ></EditorBorderColor></IconButton>
                        <span style={{fontSize:"11px",display:"block",fontFamily:"Roboto, sans-serif",textAlign:"center",marginTop:"5px"}} >{pharse('editProfile')}</span>
                </span>
            </MuiThemeProvider>;
        }
        if(window.uid != this.props.id) {
            url =  mooConfig.url.base + '/conversations/ajax_send/' + window.userId;
            sendMessage = <MuiThemeProvider muiTheme={iconNotActive}>
                <span onClick={() => this.handleClickSendMessage(url)} style={{height: "60px", padding: "10px 0", textAlign: "center", flex: "1"}}>
                    <IconButton style={{height: "35px", padding: "0"}} ><CommunicationMessage ></CommunicationMessage></IconButton>
                    <span style={{fontSize:"11px",display:"block",fontFamily:"Roboto, sans-serif",textAlign:"center",marginTop:"5px"}} >{pharse('message')}</span>
                </span>
            </MuiThemeProvider>;
        }
        if (this.props.button.userCase == 4 ) {
                requestSent = <MuiThemeProvider muiTheme={iconNotActive}>
                    <span onClick={() => this.handleChange(_.get(this.props,'id',0),this.props.button.userCase)}  style={{height: "60px", padding: "10px 0", textAlign: "center", flex: "1"}}>
                        <IconButton style={{height: "35px", padding: "0"}} ><ContentClear ></ContentClear></IconButton>
                            <span style={{fontSize:"11px",display:"block",fontFamily:"Roboto, sans-serif",textAlign:"center",marginTop:"5px"}} >{pharse('cancelRequest')}</span>
                    </span>
                </MuiThemeProvider>;
            }
            if (this.props.button.userCase == 3 ) {
                const { anchorEl } = this.state;
                respond = <MuiThemeProvider muiTheme={iconNotActive}>
                
                
                <span onClick={() => this.handleChange(_.get(this.props,'id',0),this.props.button.userCase)} style={{height: "60px", padding: "10px 0", textAlign: "center", flex: "1"}}>
                                
            
            <div>
                <Button
                  aria-owns={anchorEl ? 'simple-menu' : undefined}
                  aria-haspopup="true"
                  onClick={this.handleClickMenu}
                  style={{padding:"0"}}
                >
                  <SocialGroupAdd></SocialGroupAdd>
                </Button>
                <Menu
                  id="simple-menu"
                  anchorEl={anchorEl}
                  open={Boolean(anchorEl)}
                  onClose={this.handleCloseMenu}
                >
                  <MenuItem onClick={() => this.handleRespond(_.get(this.props,'id',0),1)} >{pharse("accept")}</MenuItem>
                  <MenuItem onClick={() => this.handleRespond(_.get(this.props,'id',0),0)} >{pharse("delete")}</MenuItem>
                </Menu>
            </div>
                                    <span style={{fontSize:"11px",display:"block",fontFamily:"Roboto, sans-serif",textAlign:"center",marginTop:"5px"}} >{pharse('respond')}</span>
                            </span>
                </MuiThemeProvider>;
            }
            if (this.props.button.userCase == 1 ) {
                addFriend = <MuiThemeProvider muiTheme={iconNotActive}>
                    <span onClick={() => this.handleChange(_.get(this.props,'id',0),this.props.button.userCase)}  style={{height: "60px", padding: "10px 0", textAlign: "center", flex: "1"}}>
                        <IconButton style={{height: "35px", padding: "0"}} ><SocialPersonAdd ></SocialPersonAdd></IconButton>
                            <span style={{fontSize:"11px",display:"block",fontFamily:"Roboto, sans-serif",textAlign:"center",marginTop:"5px"}} >{pharse('add')}</span>
                    </span>
                </MuiThemeProvider>;
            }
            if (this.props.button.userCase == 2 ) {
                addFriend = <MuiThemeProvider muiTheme={iconNotActive}>
                    <span onClick={() => this.handleChange(_.get(this.props,'id',0),this.props.button.userCase)}  style={{height: "60px", padding: "10px 0", textAlign: "center", flex: "1"}}>
                        <IconButton style={{height: "35px", padding: "0"}} ><SocialPersonOutline ></SocialPersonOutline></IconButton>
                            <span style={{fontSize:"11px",display:"block",fontFamily:"Roboto, sans-serif",textAlign:"center",marginTop:"5px"}} >{pharse('unFriend')}</span>
                    </span>
                </MuiThemeProvider>;
            }
            if (this.props.enableFollow == true) {
                if(this.state.follow == true) {
                    follow = <MuiThemeProvider muiTheme={iconNotActive}>
                        <span onClick={() => this.handleActionFollow()}  style={{height: "60px", padding: "10px 0", textAlign: "center", flex: "1"}}>
                            <IconButton style={{height: "35px", padding: "0"}} ><NavigationCheck ></NavigationCheck></IconButton>
                                <span style={{fontSize:"11px",display:"block",fontFamily:"Roboto, sans-serif",textAlign:"center",marginTop:"5px"}} >{pharse('following')}</span>
                        </span>
                    </MuiThemeProvider>;
                }
                else {
                    follow = <MuiThemeProvider muiTheme={iconNotActive}>
                        <span onClick={() => this.handleActionFollow()} style={{height: "60px", padding: "10px 0", textAlign: "center", flex: "1"}}>
                            <IconButton style={{height: "35px", padding: "0"}} ><CommunicationRssFeed ></CommunicationRssFeed></IconButton>
                                <span style={{fontSize:"11px",display:"block",fontFamily:"Roboto, sans-serif",textAlign:"center",marginTop:"5px"}} >{pharse('follow')}</span>
                        </span>
                    </MuiThemeProvider>;
                }
            }
        
        
        var check_menu = false;
        if (_.has(window, "feature")) {
            //feature = <MenuItem onClick={() => this.handleClick(mooConfig.url.base + '/admin/users/feature/' + window.userId )} primaryText={pharse('feature')} />
        }
        if (_.has(window, "unFeature")) {
            //unFeature = <MenuItem onClick={() => this.handleClick(mooConfig.url.base + '/admin/users/unfeature/' + window.userId )} primaryText={pharse('unFeature')}  />
        }
        if (_.has(window, "block")) {
        	check_menu = true;
        	block = <MenuItem onClick={() => this.handleClick(mooConfig.url.base + '/user_blocks/ajax_add/' + window.userId )} >{pharse("block")}</MenuItem>
        }
        if (_.has(window, "unBlock")) {
        	check_menu = true;
        	unBlock = <MenuItem onClick={() => this.handleClick(mooConfig.url.base + '/user_blocks/ajax_remove/' + window.userId )}  >{pharse("unBlock")}</MenuItem>
        }
        if(window.uid != this.props.id) {
        	check_menu = true;
        	report = <MenuItem onClick={() => this.handleClick(mooConfig.url.base + '/reports/ajax_create/user/' + window.userId )} >{pharse("reportUser")}</MenuItem>
        }
        const { anchorEl2 } = this.state;
        if (check_menu)
        {
	        moreAction = <MuiThemeProvider muiTheme={iconNotActive}>
	            <span style={{height: "60px", padding: "10px 0", textAlign: "center", flex: "1"}}>
	
	            <span>
	                <Button
	                  aria-owns={anchorEl2 ? 'simple-menu' : undefined}
	                  aria-haspopup="true"
	                  onClick={this.handleClickMenu2}
	                  style={{padding:"0"}}
	                >
	                  <MoreVertIcon />
	                </Button>
	                <Menu
	                  id="simple-menu"
	                  anchorEl={anchorEl2}
	                  open={Boolean(anchorEl2)}
	                  onClose={this.handleCloseMenu2}
	                >
	                  {feature}
	                                        {unFeature}
	                                        {block}
	                                        {unBlock}
	                                        {report}
	                </Menu>
	            </span>
	                                    <span style={{fontSize:"11px",display:"block",fontFamily:"Roboto, sans-serif",textAlign:"center",marginTop:"5px"}} >{pharse('more')}</span>
	                            </span>
	        </MuiThemeProvider>;
        }
        
        content = <div style={{display: "flex", margin: "10px 0", background: "#fff", borderTop: "1px solid #dadde1", borderBottom: "1px solid #dadde1"}}>
            {editProfile}{sendMessage}{requestSent}{respond}{addFriend}{follow}{moreAction}</div>;
                    return <div>{content}</div>;

    }
}
class UserProfileInfo extends React.Component {
    constructor(props) {
        super(props);
        this.handleClick = this.handleClick.bind(this);
    }
    componentWillMount(){
    }
    handleClick(url) {
        window.location.href = url + '?access_token='+mooConfig.access_token;
    }

    render() {
        var content,gender,birthday ;
        birthday = gender = content = <div></div>;
        var fields =[];
        
        if(mooConfig.rtl) {
            var infoStyle = {
                fontSize:"14px",display:"block",paddingBottom:"10px",fontFamily:"Roboto, sans-serif",paddingRight:"16px"
            };
        }else {
            var infoStyle = {
                fontSize:"14px",display:"block",paddingBottom:"10px",fontFamily:"Roboto, sans-serif",paddingLeft:"16px"
            };
        }
        
        if (_.has(this.props, "gender")) {  
                gender = <div style={infoStyle} >{pharse('gender')} : <div style={{display:"inline-block"}} dangerouslySetInnerHTML={{__html: this.props.genderFormat}}></div></div>
            }
        if (_.has(this.props, "birthdayFormat")) {  
                birthday = <div style={infoStyle}>{pharse('born')} : <div style={{display:"inline-block"}} dangerouslySetInnerHTML={{__html: this.props.birthdayFormat}}></div></div>
            }
        if (_.has(window, "profileFields")) {  
            
            var profileField = window.profileFields;
            Object.keys(profileField).forEach(function(obj) {
                    fields.push(<div key={obj} style={infoStyle}>{_.get(profileField[obj], "name")} : <div style={{display:"inline-block"}} dangerouslySetInnerHTML={{__html: _.get(profileField[obj], "value")}}></div></div>);
                },this);
            }
            
        var moreInfo = [];
        if (_.has(window, "moreProfileInfo")) {
            var moreProfileInfo = window.moreProfileInfo;
            Object.keys(moreProfileInfo).forEach(function(obj) {
                moreInfo.push(<div key={obj} style={infoStyle} dangerouslySetInnerHTML={{__html: _.get(moreProfileInfo[obj], "content")}}></div>);
            }, this)
        }
        
           
        return <div style={{marginBottom:"10px"}}>{gender}{birthday}{fields}{moreInfo}</div>;

    }
}
class UserProfileMenu extends React.Component {
    constructor(props) {
        super(props);
        this.handleClick = this.handleClick.bind(this);
        this.handleClickMenu = this.handleClickMenu.bind(this);
        this.handleCloseMenu = this.handleCloseMenu.bind(this);
        this.state = {
            anchorEl: null,
        };
    }
    componentWillMount(){
    }
    handleClick(url) {
        if(url) {
            window.location.href = url;
        }
    }
    handleClickMenu (event) {
        this.setState({ anchorEl: event.currentTarget });
    };
    handleCloseMenu () {
        this.setState({ anchorEl: null });
    };

    render() {
        var viewAllAlbum,content,menu_1,title,menu_2,titleTmp,topic,video,group,event,blocked,menu_3,albumContent ,media, title,url,photoContent,album,menuMore,images,cellHeight,col1,col2,col3,col4 ;
        viewAllAlbum = images = menuMore = album = photoContent = media = title = albumContent = menu_3 = blocked = group = event = video = topic = titleTmp = menu_2 = title = menu_1 = content = <div></div>;
        
        var menuBlock = {
            fontSize:"14px",display:"block",fontFamily:"Roboto, sans-serif",background:"#fff",height:"48px",position:"relative",flex: "1"
        };
        var menuUser = window.menu;
        var arrayMenu = [];
        var i = 0;
        Object.keys(menuUser).forEach(function(key) {
            //console.log(key, menuUser[key].text);
        	i++;
            switch(key) {
                default:
		                if (key == "album")
		                {
		                    
		                    //if(Object.keys(albumArray).length > 4 ) {
		                        var url1 = mooConfig.url.base + '/photos/profile_user_photo/' + window.userId + '?access_token='+mooConfig.access_token;
		                        viewAllAlbum = <div onClick={() => this.handleClick(url1)} style={{color:"#247BBA",position:"absolute",right:"10px",top:"0"}} >{pharse('viewAll')}</div>
		                    //}
		                    title = <div  style={{padding: "0 10px", textAlign: "left",height:"40px",lineHeight:"40px",position:"relative"}}>
		                        <IconButton style={{verticalAlign:"sub",width:"25px",height:"normal", padding: "0"}} ><ImageCollections color="#2196F3" viewBox="0 -9 32 32"></ImageCollections></IconButton>
		                        <span style={{display:"inline-block",verticalAlign:"baseline"}} >{menuUser[key].text}</span>
		                         {viewAllAlbum}
		                    </div>;
		                
		                if (window.albums) { 
		                    var albumArray = window.albums;    
		                    switch (Object.keys(albumArray).length){
		                        case 1 :
		                        case 2 :
		                            var images = [];
		                            var block = Object.keys(albumArray).forEach(function(obj) {
		                            var url = '';
		                                if (_.has(albumArray[obj], "Album.coverFull")) {  
		                                    media = <img src={_.get(albumArray[obj], "Album.coverFull")}/>;
		                                }
		                                if (_.has(albumArray[obj], "Album.moo_url")) {
		                                    url = _.get(albumArray[obj], "Album.moo_href") ;
		                                }
		                                images.push(<GridTile onClick={() => this.handleClick(url)} key={_.get(albumArray[obj], "Album.id")} cols={1} rows={1} >{media}</GridTile>);
		                            },this);
		                            photoContent = <GridList cols={2} >{images}</GridList>
		                        break;
		                        
		                        case 3 :
		                            var cnt = 1;
		                            var block = Object.keys(albumArray).forEach(function(obj) {
		                                var url = '';
		                                if (_.has(albumArray[obj], "Album.coverFull")) {  
		                                    media = <img src={_.get(albumArray[obj], "Album.coverFull")}/>;
		                                }
		                                if (_.has(albumArray[obj], "Album.moo_url")) {
		                                    url = _.get(albumArray[obj], "Album.moo_href") ;
		                                }
		                                if(cnt == 1) {
		                                    col1 = <GridTile onClick={() => this.handleClick(url)} key={window.userId+'-1'} cols={2} rows={2} >{media}</GridTile>
		                                }
		                                if(cnt == 2) {
		                                    col2 = <GridTile onClick={() => this.handleClick(url)} key={window.userId+'-2.1'} cols={1} rows={1} >{media}</GridTile>
		                                }
		                                if(cnt == 3) {
		                                    col3 = <GridTile onClick={() => this.handleClick(url)} key={window.userId+'-2.2'} cols={1} rows={1} >{media}</GridTile>
		                                }
		                                cnt++;                                    
		                            },this);
		                            cellHeight = 100;
		                            photoContent = <GridList  cols={3} cellHeight={cellHeight}>
		                                        {col1}
		                                    <GridTile key={window.userId+'-2'} cols={1} rows={2} >
		                                        <GridList  cols={1} cellHeight={cellHeight}>
		                                             {col2}{col3}
		                                        </GridList>
		                                    </GridTile>
		                                </GridList>;
		                        break;
		                        
		                        default :
		                            var cnt = 1;
		                            var block = Object.keys(albumArray).forEach(function(obj) {
		                                var url = '';
		                                if (_.has(albumArray[obj], "Album.coverFull")) {  
		                                    media = <img src={_.get(albumArray[obj], "Album.coverFull")}/>;
		                                }
		                                if (_.has(albumArray[obj], "Album.moo_url")) {
		                                    url = _.get(albumArray[obj], "Album.moo_href") ;
		                                }
		                                if(cnt == 1) {
		                                    col1 = <GridTile onClick={() => this.handleClick(url)} key={window.userId+'-1'} cols={3} rows={3} >{media}</GridTile>
		                                }
		                                if(cnt == 2) {
		                                    col2 = <GridTile onClick={() => this.handleClick(url)} key={window.userId+'-2.1'} cols={1} rows={1} >{media}</GridTile>
		                                }
		                                if(cnt == 3) {
		                                    col3 = <GridTile onClick={() => this.handleClick(url)} key={window.userId+'-2.2'} cols={1} rows={1} >{media}</GridTile>
		                                }
		                                if(cnt == 4) {
		                                    col4 = <GridTile onClick={() => this.handleClick(url)} key={window.userId+'-2.3'} cols={1} rows={1} >{media}</GridTile>
		                                }
		                                cnt++;                                    
		                            },this);
		                            cellHeight = 66;
		                            photoContent = <GridList  cols={4} cellHeight={cellHeight}>
		                                    {col1}
		                                <GridTile key={window.userId+'-2'} cols={1} rows={3} >
		                                    <GridList  cols={1} cellHeight={cellHeight}>
		                                        {col2}{col3}{col4}
		                                    </GridList>
		                                </GridTile>
		                            </GridList>;
		                        break;
		                    }
		                }
		                albumContent = <div>{photoContent}</div>;
		                album = <div style={{fontSize:"14px",display:"block",fontFamily:"Roboto, sans-serif",background:"#fff",margin:"10px -6px",position:"relative"}}>{title}{albumContent}</div>
		            }
                	if (i == 1)
                	{
                		titleTmp = <div  style={{textAlign: "center",height:"48px",lineHeight:"48px"}}>
                        <div style={{verticalAlign:"baseline",whiteSpace:"nowrap",maxWidth:"160px",textOverflow:"ellipsis",overflow:"hidden"}} >{menuUser[key].text}</div>
                        </div>;
                        title = <RaisedButton fullWidth={true} label={titleTmp} style={{boxShadow:"none"}} overlayStyle={{height:"auto",boxShadow:"none"}} buttonStyle={{height:"auto",boxShadow:"none"}} labelStyle={{fontSize:"16px",color:"#000",padding:"0",textTransform:"none",textAlign:"left",display: "block"}} />
                        menu_1 = <div onClick={() => this.handleClick(menuUser[key].url)} style={menuBlock}>{title}</div>
                	}
                	else if (i == 2)
                	{
                		titleTmp = <div  style={{textAlign: "center",height:"48px",lineHeight:"48px"}}>
                		<div style={{verticalAlign:"baseline",whiteSpace:"nowrap",maxWidth:"160px",textOverflow:"ellipsis",overflow:"hidden"}} >{menuUser[key].text}</div>
                        </div>;
                        title = <RaisedButton fullWidth={true} label={titleTmp} style={{boxShadow:"none"}} overlayStyle={{height:"auto",boxShadow:"none"}} buttonStyle={{height:"auto",boxShadow:"none"}} labelStyle={{fontSize:"16px",color:"#000",padding:"0",textTransform:"none",textAlign:"left",display: "block"}} />
                        menu_2 = <div onClick={() => this.handleClick(menuUser[key].url)} style={menuBlock}>{title}</div>
                	}
                	else if (i == 3)
                	{
                		titleTmp = <div  style={{textAlign: "center",height:"48px",lineHeight:"48px"}}>
                		<div style={{verticalAlign:"baseline",whiteSpace:"nowrap",maxWidth:"160px",textOverflow:"ellipsis",overflow:"hidden"}} >{menuUser[key].text}</div>
                        </div>;
                        title = <RaisedButton fullWidth={true} label={titleTmp} style={{boxShadow:"none"}} overlayStyle={{height:"auto",boxShadow:"none"}} buttonStyle={{height:"auto",boxShadow:"none"}} labelStyle={{fontSize:"16px",color:"#000",padding:"0",textTransform:"none",textAlign:"left",display: "block"}} />
                        menu_3 = <div onClick={() => this.handleClick(menuUser[key].url)} style={menuBlock}>{title}</div>
                	}
                	else
                	{
                        var key_id = menuUser[key].text + "-key";
                        arrayMenu.push(<MenuItem onClick={() => this.handleClick(menuUser[key].url)} key={key_id} >{menuUser[key].text}</MenuItem>);
                	}
            }
        },this);
        const { anchorEl } = this.state;
        menuMore = <div style={{display:"block",height: "48px",textAlign: "center", flex: "1"}}>
                <Button
                  aria-owns={anchorEl ? 'simple-menu' : undefined}
                  aria-haspopup="true"
                  onClick={this.handleClickMenu}
                  style={{width:"25px",height: "48px", padding: "0"}}
                >
                  <MoreVertIcon />
                </Button>
                <Menu
                  id="simple-menu"
                  anchorEl={anchorEl}
                  open={Boolean(anchorEl)}
                  onClose={this.handleCloseMenu}
                >
                  <div className="profile_menu_scroll">{arrayMenu}</div>
                </Menu>  
                            </div>

        return <div><div style={{display: "flex",margin:"0 -8px", background: "#fff", borderTop: "1px solid #dadde1", borderBottom: "1px solid #dadde1"}}>{menu_1}{menu_2}{menu_3}{menuMore}</div>{album}</div>;

    }
}
class UserFeed extends React.Component {
     constructor(props) {
        super(props);
        this.handleViewAllComment = this.handleViewAllComment.bind(this);
        this.state = {
            showViewAllComment:true,
        };
    }
    handleViewAllComment() {
        if(_.has(window,"idToGetComment") && _.has(window,"typeToGetComment")) {
            CommentActions.fetchComment(window.idToGetComment,window.typeToGetComment);
        }else if(_.has(window,"isPhotoFeed")) {
            CommentActions.fetchComment(window.photoFeedId,'Photo_Photo');
        }
        else {
            CommentActions.fetchComment(window.activityId,'Activity');
        }
        this.setState({showViewAllComment: !this.state.showViewAllComment});
    }
    render() {
        var commentStatus,cmStatus;
        var viewAllComment = <div></div>;
        var postFeedId = 0;
        if(window.uid != window.userId) {
            postFeedId = window.userId;
        }
        if(this.props.activites.get('isOpen') == true ){
            
            if (_.has(window, "unBlock")) {
                return <MuiThemeProvider >
                            <div style={{margin:"10px -6px 0"}}>
                                <div style={{marginTop:"10px",background:"#fff",padding:"10px",textAlign:"center",fontFamily:"Roboto, sans-serif"}} >{pharse('notFound')}</div>
                            </div>
                            </MuiThemeProvider>;
            }
            else {
                if(this.props.activites.get('isPrivateFeed') == true ) {
                    var messtmp = this.props.activites.get('records');
                    return <MuiThemeProvider >
                        <div style={{marginTop:"10px",background:"#fff",padding:"10px",textAlign:"left",fontFamily:"Roboto, sans-serif"}}>
                            <div style={{fontSize:"28px",color:"#3E3E3E"}} >{messtmp.message}</div>
                        </div>
                    </MuiThemeProvider>;
                } else if(this.props.activites.get('records').count() > 0 ){
                    var items = [];
                    var isPhone = this.props.isPhone;

                    var isFetching = this.props.activites.get('isFetching') ? true : false ;  
                    var process = <LoadMore isFetching={isFetching} ></LoadMore>;

                    var singleActivity,singleComment;
                    singleActivity = window.activityId == 0 ? false : true;
                    singleComment = window.activityId == 0 ? true : false;
                    this.props.activites.get('records').forEach(function(item){
                        items.push(<ActivityItem {...item} singleActivity={singleActivity} key={item.id} isPhone={isPhone} likes={this.props.likes} reactions={this.props.reactions} singleComment={singleComment} page="users.view"/>);
                        items.push(<div key={'a'+item.id} style={{height:'7px'}}/>);
                    }.bind(this));

                    if(window.activityId == 0) { 
                        return <MuiThemeProvider >
                            <div>
                                <div style={{margin:"10px -6px 0",paddingBottom:"0"}} ><ACForm {...this.props} target_id={postFeedId} type={"User"} /><div style={{height:'7px'}}/>{items}{process}</div>
                           </div>
                        </MuiThemeProvider>;
                    }
                    else {
                        commentStatus = this.props.comments.get('cmStatus');
                        var block = commentStatus.forEach(function(obj) {
                                cmStatus = obj;
                        }, this);
                        
                        if(_.has(window,"commentId") ) {
                            if(this.state.showViewAllComment) {
                                viewAllComment = <div onClick={() => this.handleViewAllComment()} style={{fontFamily:"Roboto, sans-serif",background:"#fff",color: "#247BBA",display: "block", padding: "10px 10px 0", margin: "0", position: "relative"}} >{pharse('viewAllComment')}</div>
                            }
                        }
                        return <MuiThemeProvider >
                        <div>
                            <div style={{margin:"0 -6px 0",paddingBottom:"0"}} >{items}{viewAllComment}<CommentItem {...this.props} commentStatus={cmStatus} likes={this.props.likes} reactions={this.props.reactions} /></div>
                       </div>
                        </MuiThemeProvider>;
                    }
                }else {
                    return <MuiThemeProvider >
                            <div style={{margin:"10px -6px 0"}}>
                                <ACForm {...this.props} target_id={postFeedId} type={"User"} />
                                <div style={{marginTop:"10px",background:"#fff",padding:"10px",textAlign:"center",fontFamily:"Roboto, sans-serif"}} >{pharse('notFound')}</div>
                            </div>
                            </MuiThemeProvider>;
                }  
            }
        }
        return null
    }
}
class UserProfileCompletion extends React.Component {
     constructor(props) {
        super(props);
    }
    handleClick(url) {
        if(url) {
            window.location.href = url;
        }
    }

    render() {
        var linearProgress,title,next,update;
        update = next = title = linearProgress = close = <div></div>;
        var profileCompletion =  JSON.parse(window.profileCompletion);

        if (_.has(profileCompletion, "is_show_widget") && _.get(profileCompletion, "is_show_widget") == true ) {
            if (_.has(profileCompletion, "hide_widget_url")){
                close = <div style={{padding: "0", textAlign: "left",position:"relative", marginRight: "-22px"}}><span>
                        <Button
                          aria-haspopup="true"
                          onClick={() => this.handleClick(mooConfig.url.full +  mooConfig.url.base + _.get(profileCompletion, "hide_widget_url"))}
                          style={{padding:"0", float: "right"}}
                        >
                          <CloseIcon />
                        </Button>
                        <div style={{clear: "both"}}></div>
                    </span></div>;
            }
            if (_.has(profileCompletion, "total_percent_title") && _.has(profileCompletion, "total_percent") ) {
                title = <div  style={{padding: "0", textAlign: "left",height:"40px",lineHeight:"40px",position:"relative"}}>{profileCompletion.total_percent_title} </div>;
            }
            if (_.has(profileCompletion, "progress_bar_color") && _.has(profileCompletion, "total_percent") ) {
                linearProgress = <LinearProgress mode="determinate" style={{height:"20px",background:profileCompletion.remaining_bar_color}} color={profileCompletion.progress_bar_color} value={profileCompletion.total_percent} />;
            }
            if(profileCompletion.total_percent != 100) {
                if (_.has(profileCompletion, "next") && _.has(profileCompletion, "next_percent") ) {
                    next = <div  style={{padding: "0", textAlign: "left",height:"40px",lineHeight:"40px",position:"relative"}}><i style={{fontStyle:"normal",marginRight:"10px"}} >{pharse('completionNext')}</i>{profileCompletion.next}<i style={{fontStyle:"normal",marginLeft:"10px"}} >( {profileCompletion.next_percent} % )</i></div>;
                }
                update = <div  onClick={() => this.handleClick(mooConfig.url.full +  mooConfig.url.base + _.get(profileCompletion, "next_url"))} style={{color:"rgb(36, 123, 186)",padding: "0", textAlign: "left",height:"40px",lineHeight:"40px",position:"relative"}}>{pharse('completionUpdateProfile')} </div>;
            }
            return <div style={{padding:"10px",margin:"0 -8px", background: "#fff", borderTop: "1px solid #dadde1", borderBottom: "1px solid #dadde1"}}>{close}{title}{linearProgress}{next}{update}</div>;
        }
        else {
            return <div></div>   ;
        }
    }
}

function UserViewContent(props) {
    return <UserView {...props} />
}

export default UserViewContent;
