var path = require('path');

var BUILD_DIR = path.resolve(__dirname, "../../../../webroot/moo_app/js");
var LIVEVIDEO_DIR = path.resolve(__dirname, "../../../../webroot/livevideo/js");
var APP_DIR = path.resolve(__dirname, 'src');

const webpack = require('webpack');
const { WebpackManifestPlugin } = require('webpack-manifest-plugin');
const optionsManifest = {  };

module.exports = function(configName) {
    var config ;
    switch(configName) {
        case 'webpack':
            config =  {
                mode: 'none',
                entry:{
                    'vendor':['react','react-dom','whatwg-fetch'],
                    'home.index': APP_DIR +'/home.index.js',
                    'activities.everyone': APP_DIR +'/activities.everyone',
                    'activities.photo.album': APP_DIR +'/activities.photo.album',
                    'activities.tag.user': APP_DIR +'/activities.tag.user',
                    'activities.photo.feed': APP_DIR +'/activities.photo.feed',
                    'blogs.browse': APP_DIR +'/blogs.browse',
                    'topics.browse': APP_DIR +'/topics.browse',
                    'videos.browse': APP_DIR +'/videos.browse',
                    'groups.browse': APP_DIR +'/groups.browse',
                    'events.browse': APP_DIR +'/events.browse',
                    'albums.browse': APP_DIR +'/albums.browse',
                    'users.browse': APP_DIR +'/users.browse',
                    'photos.browse': APP_DIR +'/photos.browse',
                    'activities.view': APP_DIR +'/activities.view',
                    'blogs.view': APP_DIR +'/blogs.view',
                    'topics.view': APP_DIR +'/topics.view',
                    'videos.view': APP_DIR +'/videos.view',
                    'albums.view': APP_DIR +'/albums.view',
                    'photos.view': APP_DIR +'/photos.view',
                    'users.view': APP_DIR +'/users.view',
                    'events.view': APP_DIR +'/events.view',
                    'groups.view': APP_DIR +'/groups.view',
                    'profile.friend': APP_DIR +'/profile.friend',
                    'profile.block.member': APP_DIR +'/profile.block.member',
                    'profile.blog': APP_DIR +'/profile.blog',
                    'profile.topic': APP_DIR +'/profile.topic',
                    'profile.video': APP_DIR +'/profile.video',
                    'profile.group': APP_DIR +'/profile.group',
                    'profile.event': APP_DIR +'/profile.event',
                    'profile.photo': APP_DIR +'/profile.photo',
                    'mobile.action': APP_DIR +'/mobile.action',
                    'users.follow': APP_DIR +'/users.follow',
                    'friend.request': APP_DIR +'/friend.request',
                    'livevideo.player':APP_DIR +'/livevideo.player',
                    'livevideos.browse':APP_DIR +'/livevideos.browse',
                },
                output: {
                    path: BUILD_DIR,
                    filename: '[name].bundle.js',
                    //filename: '[chunkhash].[name].bundle.js'
                },
                module : {
                    rules : [
                        {
                            test : /\.js?/,
                            include : APP_DIR,
                            exclude: /(node_modules|bower_components)/,
                            use : {
                                loader: 'babel-loader',
                                query: {
                                    presets: ['es2015', 'react', 'stage-3']
                                }
                            }
                        },
                        {
                            test: /\.js?/,
                            include : LIVEVIDEO_DIR,
                            use: {
                                loader: 'ts-loader',
                                options: {
                                    transpileOnly: true,
                                }
                            },
                            exclude: /node_modules/,
                        }
                    ]
                },
                plugins: [
                    /*
                    new webpack.optimize.CommonsChunkPlugin({
                        names: ['vendor','manifest'], // Specify the common bundle's name.
                        //minChunks: function (module) {
                            // this assumes your vendor imports exist in the node_modules directory
                        //    return module.context && module.context.indexOf('node_modules') !== -1;
                        //}
                    }),
                    */
                ]
            };
            break;
        case 'BUILD_DIR':
            config = BUILD_DIR;
            break;
        case 'APP_DIR':
            config = APP_DIR;
            break;
        default:
            config = {};
    }
    return config;
}
