const webpackMerge = require('webpack-merge');
const commonConfig = require('./webpack.config.base.js');
const webpack = require('webpack');
const CompressionPlugin = require("compression-webpack-plugin");
const UglifyJsPlugin = require('uglifyjs-webpack-plugin');
module.exports = function(env) {
    return webpackMerge(commonConfig('webpack'), {
        mode: 'production',
        output: {
            path: commonConfig('BUILD_DIR'),
            //filename: '[name].bundle.min.js'
        },
        optimization: {
            minimizer: [new UglifyJsPlugin({
                cache: true,
                parallel: true,
                uglifyOptions: {
                    warnings: false,
                }
            })],
        },
        plugins: [
            new CompressionPlugin({
                asset: "[path].gz[query]",
                algorithm: "gzip",
                test: /\.js$|\.html$/,
                threshold: 10240,
                minRatio: 0.8
            })
        ]
    })
};
