<?php

$this->MooApp->loading();

$this->Html->css(array('MooApp.feed/activites','MooApp.feed/emoji','MooApp.main','MooApp.feed/plugin'), array('block' => 'mooAppOptimizedCss','minify'=>false));

if (Configure::read('core.map_mode')) {
    $this->Html->css(array('MooApp.feed/leaflet'), array('block' => 'mooAppOptimizedCss','minify'=>false));
}

$this->MooGzip->script(array(
        'zip'=>'activities.everyone.bundle.js.gz',
        'unzip'=>'MooApp.activities.everyone.bundle'
));

$this->addPhraseJs(array(
        'like' => __("%s Like"),
        'likes' => __("%s Likes"),
        'dislike' => __("%s Dislike"),
        'dislikes' => __("%s Dislikes"),
        'comment' => __("%s Comment"),
        'comments' => __("%s Comments"),
        'time' => __("Time"),
        'location' => __("Location"),
        'address' => __("Address"),
        'members' => __("members"),
        'newFeedPlaceholder' => __("What's on your mind?"),
        'report' => __("Report Activity"),
        'deleteFeed' => __("Delete Activity"),
		'editFeed' => __("Edit Activity"),
        'reply' => __("Reply"),
        'replies' => __('Replies'),
        'deleteComment' => __("Delete Comment"),
        'openComment' => __('Open Comment'),
        'closeComment' => __('Close Comment'),
        'whoOnline' => __("People You May Know"),
        'remove' => __('Remove'),
        'cancel' => __('Cancel'),
        'add' => __('Add'),
        'respond' => __('Respond'),
        'yes' => __('Accept Friend Request'),
        'no' => __('Reject Friend Request'),
        'userStories' => __("User Stories"),
        )
);

/*CUSTOM FOR SPOTLIGHT PROFILE*/
if (Configure::read('Spotlight.spotlight_enabled')) :

   $this->Html->css(array('https://cdnjs.cloudflare.com/ajax/libs/slick-carousel/1.6.0/slick.min.css','https://cdnjs.cloudflare.com/ajax/libs/slick-carousel/1.6.0/slick-theme.min.css'), array('block' => 'mooAppOptimizedCss','minify'=>false));

   $spotlight ='';
   $spotlightUserArray = array();
   $beforeRenderSpotlight = new CakeEvent("View.Mooapp.activities.ajax_browse.renderSpotlightForApp", $this, array());
   $this->getEventManager()->dispatch($beforeRenderSpotlight);
   $result = $beforeRenderSpotlight->result['result'];
   $canJoin = $result['canJoin'];
   $spotUsers = $result['topSpotlight'];
   if ( !empty( $spotUsers ) ):
       foreach ($spotUsers as $i => $user):
           $spotlightUserArray[$i]['id'] =  $user['User']['id'];
           $spotlightUserArray[$i]['url'] =  FULL_BASE_URL . str_replace('?','',mb_convert_encoding($user['User']['moo_href'], 'UTF-8', 'UTF-8')) ;
           $spotlightUserArray[$i]['avatar'] =  $this->Moo->getImageUrl(array('User'=>$user['User']), array('prefix' => '200_square'));
       endforeach;
   endif;
   $spotlightUserArray =  json_encode($spotlightUserArray);
endif;
/*END CUSTOM FOR SPOTLIGHT PROFILE*/

/*CUSTOM FOR STORY WIDGET*/
if(Configure::read('Feedstory.feedstory_enabled')) :
    $storyModel2 = MooCore::getInstance()->getModel("Feedstory.Feedstory");
    $storyModel = MooCore::getInstance()->getModel("Feedstory.Feedstory");
    $storyModel->bindModel(array
    (
        'belongsTo' => array
        (
            'Activity' => array
            (
                'className'     => 'Activity',
                'foreignKey' => false,
                'conditions' => array
                (
                    'Activity.id = Feedstory.target_id'
                )
            )
        )
    ));
    $stories = $storyModel->getStories($uid,50);

    foreach($stories as $k => $rs):
        $story = $storyModel2->find('first', array(
            'conditions' => array('Feedstory.user_id' => $rs['Feedstory']['user_id']),
        ));
        $activity = MooCore::getInstance()->getModel('Activity_Activity')->findById($story['Feedstory']['target_id']);
        $stories[$k]['Activity']= $activity['Activity'];
        $stories[$k]['Feedstory']['isFriend']= true;
    endforeach;
    $storyModel->bindModel(array
    (
        'belongsTo' => array
        (
            'Activity' => array
            (
                'className'     => 'Activity',
                'foreignKey' => false,
                'conditions' => array
                (
                    'Activity.id = Feedstory.target_id'
                )
            )
        )
    ));
    $my_story = $storyModel->find('all',array(
        'conditions' => array('Feedstory.user_id' => $uid),
    ));

    $result = array_merge ($my_story,$stories);

    foreach($result as $k => $rs):

        $imageArray = array();
        $result[$k]['User']['avatar'] = $this->Moo->getItemPhoto(array('User' => $rs['User']), array('prefix' => '50_square'), array(), true);
        if ($rs['Activity']['item_type'] == 'Photo_Album') {
            $ids = $rs['Activity']['items'];

            $photoModel = MooCore::getInstance()->getModel('Photo_Photo');
            $photo = $photoModel->find('first', array('conditions' => array('Photo.id' => $ids),
                //'limit' => 4
            ));

            $imageArray = array();

            $imageArray['idPhoto'] = $photo['Photo']['id'];
            $imageArray['idAlbum'] = !empty($photo['Album']) ? $photo['Album']['id'] : "";
            $imageArray['type'] = $photo['Photo']['type'];
            $imageArray['albumType'] = $photo['Photo']['album_type'] == '' ? 'Photo_Album' : $photo['Photo']['album_type'];
            $imageArray['albumTypeId'] = $photo['Photo']['album_type'] == '' ? $photo['Photo']['target_id'] : $photo['Photo']['album_type_id'];
            $imageArray['300_square'] = $this->Photo->getImage($photo, array('prefix' => '300_square'));
            $result[$k]['Activity']['image']= $imageArray;
        }
        if ($rs['Activity']['action'] == 'video_activity') {

        }
        if ($rs['Activity']['action'] == 'wall_post_link') {
            $link = unserialize($rs['Activity']['params']);
            if ( strpos( $link['image'], 'http' ) === false ):
                $link_image = $this->storage->getUrl($activity['Activity']["id"],'',$link['image'],"links") ;//$this->request->webroot . 'uploads/links/' .  $link['image'] ;
            else:
                $link_image = $link['image'];
            endif;
            //echo '<pre>';print_r($fuck);die;
            $imageArray = array();
            $imageArray['300_square'] = $link_image;
            $result[$k]['Activity']['image']= $imageArray;
        }

        if ($rs['Activity']['action'] == 'wall_post_background') {
            $oBackgroundStatusHelper = MooCore::getInstance()->getHelper('StatusBackground_StatusBackground');
            $backgroundModel = MooCore::getInstance()->getModel('StatusBackground');
            $backgroundStatus = $backgroundModel->findById($rs['Activity']['status_background_id']);

            if(!empty($backgroundStatus)){
                $style = '';
                if($backgroundStatus['StatusBackground']['type'] == 'color'){
                    $style = $backgroundStatus['StatusBackground']['color'];
                    $type =  'color';
                }else if($backgroundStatus['StatusBackground']['type'] == 'image'){
                    $style =  '<div class="feedStoryBg" style="background-image: url('.$oBackgroundStatusHelper->getImage($backgroundStatus).')" ></div>';
                    $type =  'image';
                }else if($backgroundStatus['StatusBackground']['type'] == 'gradient'){
                    $arrayTmp  = json_decode($backgroundStatus['StatusBackground']['gradient'],true);
                    $style = '<div class="feedStoryBg" style=" ' . $arrayTmp['css'] . '" ></div>';
                    $type =  'gradient';
                }else if($backgroundStatus['StatusBackground']['type'] == 'custom'){
                    $tmp = $backgroundStatus['StatusBackground']['style'];
                    $style = '<div class="feedStoryBg" style=" ' . $tmp . '" ></div>';
                    $type =  'custom';
                }
            }
            $result[$k]['Activity']['action']= 'wall_post_background';
            $result[$k]['Activity']['style']= $style;
            $result[$k]['Activity']['type']= $type;
        }

    endforeach;
    //echo '<pre>';print_r($result);die;
    $storiesWidgets =  json_encode($result);
endif;
/*END CUSTOM FOR STORY WIDGET*/

?>

<?php $this->start('mooAppOptimizedContent'); ?>
<script type="text/javascript">
	window.type = '<?php echo $type;?>';
    window.uid = <?php echo $uid; ?>;
    <?php if(Configure::read('Spotlight.spotlight_enabled') && isset($canJoin) && $canJoin == 0 ): ?>
    window.show_spotlight_profile_btn = true;
    <?php endif; ?>
    <?php if(isset($spotlightUserArray) && !empty($spotlightUserArray) ): ?>
        window.spotlight_user = <?php echo $spotlightUserArray ?>;
    <?php endif; ?>
    <?php if(isset($storiesWidgets) && !empty($storiesWidgets) ): ?>
    window.storiesWidget = <?php echo $storiesWidgets ?>;
    <?php endif; ?>
    <?php if(isset($spotlightUserArray) && !empty($spotlightUserArray) ): ?>
    window.spotlight_user = <?php echo $spotlightUserArray ?>;
    <?php endif; ?>
    <?php if(Configure::read('MooApp.show_more_button_what_new_box')==1): ?>
    window.show_more_button = true;
   <?php else: ?>
    window.show_more_button = false;
   <?php endif; ?>
   <?php if(Configure::read('MooApp.mooapp_hide_what_new')==1): ?>
    window.mooapp_hide_what_new = true;
   <?php else: ?>
    window.mooapp_hide_what_new = false;
   <?php endif; ?>
  <?php if (!empty($cuser) && !$cuser['confirmed'] && Configure::read('core.email_validation')) : ?>
    window.email_validation = false;
//     document.getElementById("resend_validation_link").addEventListener("click", resendValidation);
//    
//    function resendValidation() {
//        
//        var xhr = new XMLHttpRequest();
//        xhr.open('POST', mooConfig.url.base + '/users/resend_validation', true);
//        xhr.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
//        xhr.onload = function () {
//            var div = '<div class="confirm_send_email_validate" style="font-size: 15px;color: #f00;font-weight: 600;margin-top: 19px;"> <?php echo  __("Validation link has been resent.") ?> </div>';
//            document.getElementById('confirm_remindMessage').innerHTML += div;
//        };
//        xhr.send();
//    }
   <?php else : ?>
    window.email_validation = true;
  <?php endif; ?>
  <?php 
    $renderAppOptimizedContent= new CakeEvent("View.Mooapp.activities.ajax_browse.renderAppOptimizedContent", $this, array());
    $this->getEventManager()->dispatch($renderAppOptimizedContent);
  ?>

  window.show_live_button = false;
  <?php if(Configure::check('Livevideo.livevideo_enabled') && Configure::read('Livevideo.livevideo_enabled')): ?>
    <?php
    $aUserAcos = explode(',', $cuser['Role']['params']);
    if (!empty($cuser) && in_array('livevideo_stream', $aUserAcos)): ?>
        window.show_live_button = true;
    <?php endif; ?>
  <?php endif; ?>
</script>
<?php $this->end(); ?>

