<?php


$isLive = $this->Livevideo->isLiveByItem($livevideo);

$title = $this->Livevideo->getTitleByItem($livevideo);
if (empty($title)){
    $title = ($isLive ? __d('livevideo', 'Live '): '');
}else{
    $title = ($isLive ? __d('livevideo', 'Live - '): ''). $title;
}
$color = $isLive ?"red":"black";


$this->MooApp->loading();
$this->Html->css(array('MooApp.main','MooApp.feed/emoji'), array('block' => 'mooAppOptimizedCss','minify'=>false));
$this->addPhraseJs(array(
        'in' => __("posted in"),
        'by' => __("by"),
        'Like' => __("Like"),
        'like' => __("%s Like"),
        'likes' => __("%s Likes"),
        'dislike' => __("%s Dislike"),
        'Dislike' => __("Dislike"),
        'dislikes' => __("%s Dislikes"),
        'comment' => __("%s Comment"),
        'comments' => __("%s Comments"),
        'noComment' => __("Be the first person comment on this"),
        'edit' => __("Edit Entry"),
        'delete' => __("Delete Entry"),
        'report' => __("Report Entry"),
		'deleteComment' => __("Delete Comment"),
        'reply' => __("Reply"),
        'replies' => __('Replies'),
        'viewAllComment' => __('View all comments'),
        'the_live_video_has_ended' => __d('livevideo', 'The live video has ended.'),
        'start_playing' => __d('livevideo', 'Start Playing'),
        'stop_playing' => __d('livevideo', 'Stop Playing'),
        )
);

//CUSTOM FOR BOOKMARK PLUGIN
if (Configure::read('Bookmark.bookmark_enabled')) :
    $renderBookmarkItem = new CakeEvent("View.Mooapp.ViewerBookmarkItem", $this, array('object_type' => 'Blog_Blog', 'object_id' => $livevideo['Livevideo']['id']));
    $this->getEventManager()->dispatch($renderBookmarkItem);
    $result = $renderBookmarkItem->result['result'];
    $isViewerBookmark = 0;
    if(isset($result['isViewerBookmark'])) {
        $isViewerBookmark = $result['isViewerBookmark'];
    }
endif;
//END CUSTOM FOR BOOKMARK PLUGIN
$comment_id = !empty( $this->request->named['comment_id'] ) ? $this->request->named['comment_id'] : 0;
$reply_id = !empty( $this->request->named['reply_id'] ) ? $this->request->named['reply_id'] : 0;


if (empty($livevideo)) {
// Do nothing
}else{
    $isViewerLiked = $isViewerDisliked = false;
    if (!empty( $livevideo['Like']) && $livevideo['Like']['user_id'] == $uid   ){
        $livevideo['Like']['thumb_up'] == 1 ? $isViewerLiked = true : $isViewerDisliked = true;
    }
    $data = array(
        'streamId'=>$livevideo['Livevideo']['stream_id'],
        'live' =>$livevideo['Livevideo']['live'],
        'snapshot'=>$this->Livevideo->getSnapshotByStreamId($livevideo['Livevideo']['stream_id']),
        'videoSource'=>$this->Livevideo->getVideoLinkByStreamId($livevideo['Livevideo']['stream_id']),
        // Default item which similar to blog item ...
        'id'=> $livevideo['Livevideo']['id'],
        'title' => $title,
        'type' => $livevideo['Livevideo']['moo_type'],
        'url' => FULL_BASE_URL .  str_replace('?','',mb_convert_encoding($livevideo['Livevideo']['moo_href'], 'UTF-8', 'UTF-8')),
        'published' => $livevideo['Livevideo']['created'],
        'publishedTranslated' => $this->Moo->getTime($livevideo['Livevideo']['created'], Configure::read('core.date_format'), $utz),
        'privacy' => $livevideo['Livevideo']['privacy'],
        'commentCount' => $livevideo['Livevideo']['comment_count'],
        'shareCount' => $livevideo['Livevideo']['share_count'],
        'likeCount' => $livevideo['Livevideo']['like_count'],
        'dislikeCount' => $livevideo['Livevideo']['dislike_count'],
        'userId' => $livevideo['Livevideo']['user_id'],
        'userName' => $livevideo['User']['name'],
        'userUrl' => FULL_BASE_URL . str_replace('?','',mb_convert_encoding($livevideo['User']['moo_href'], 'UTF-8', 'UTF-8')) ,
        'shareAction' => "live_item_detail" ,
        'isViewerLiked' => $isViewerLiked ,
        'isViewerDisliked' => $isViewerDisliked ,
    );

    // React plugin is supported by making a fake hook of Api.View.ApiBlog.afterRenderApiBlogDetail
    $afterRenderApiBlog = new CakeEvent("Api.View.ApiBlog.afterRenderApiBlogDetail", $this, array(
        'item_id' => $livevideo['Livevideo']['id'],
        'item_type' => $livevideo['Livevideo']['moo_type'],
        'data' => $livevideo,
        'data_json' => $data,
    ));

    $this->getEventManager()->dispatch($afterRenderApiBlog);
    if(!empty($afterRenderApiBlog->result['result'])) {
        $result = $afterRenderApiBlog->result['result'];
        $data = array_merge($data, $result);
    }
}

?>

<?php $this->start('mooAppOptimizedContent'); ?>
 <script type="text/javascript">
     <?php if($comment_id): ?>
    window.commentId = <?php echo $comment_id ?>;
    window.idToGetComment = '<?php echo $livevideo['Livevideo']['id'] ?>';
    window.typeToGetComment = 'Livevideo_Livevideo';
    <?php endif; ?>
    <?php if($reply_id): ?>
    window.replyId = <?php echo $reply_id ?>;
    <?php endif; ?>
    <?php if (isset($isViewerBookmark) && Configure::read('Bookmark.bookmark_enabled')): ?>
    window.isViewerBookmark = <?php echo $isViewerBookmark; ?>;
    <?php endif; ?>
    window.liveId = '<?php echo $livevideo['Livevideo']['id']; ?>' ;
    window.livevideo = <?php echo json_encode($data); ?> ;
    <?php if ($livevideo['User']['id'] == $uid || ( !empty($cuser) && $cuser['Role']['is_admin'] )): ?>
     window.canEdit  = true ;
    <?php endif; ?>
   <?php if ( ($livevideo['Livevideo']['user_id'] == $uid ) || ( !empty( $livevideo['Livevideo']['id'] ) && !empty($cuser) && $cuser['Role']['is_admin'] ) ): ?>
     window.canDelete  = true ;
    <?php endif; ?>

 </script>

<?php if ($isLive) : ?>
    <script src="https://webrtc.github.io/adapter/adapter-latest.js"></script>
    <script src="https://code.jquery.com/jquery-3.4.1.min.js"  crossorigin="anonymous"></script>
    <script type="text/javascript">
        console.log("abc");
        //import {Player} from "../js/player.js"

        window.playerConfig = {
            initWebRTCAdaptorAuto:false,
            path:'<?php echo Configure::read('Livevideo.livevideo_ant_media_url').'/websocket'; ?>',
            jwt:'<?php echo $jwt; ?>',
            streamId:'<?php echo $livevideo['Livevideo']['stream_id']; ?>',
            accessToken: '<?php echo $this->request->query['access_token']; ?>',
            api:{
                start_stream:'<?php echo $this->Html->url(array(
                    'plugin' => 'livevideo',
                    'controller' => 'publishing',
                    'action' => 'start_stream'
                ),true); ?>',
                stop_stream:'<?php echo $this->Html->url(array(
                    'plugin' => 'livevideo',
                    'controller' => 'publishing',
                    'action' => 'stop_stream'
                ),true); ?>',
                no_stream_exist:'<?php echo $this->Html->url(array(
                    'plugin' => 'livevideo',
                    'controller' => 'publishing',
                    'action' => 'no_stream_exist'
                ),true); ?>',
                get_count: '<?php echo "https://".Configure::read('Livevideo.livevideo_ant_media_url')."/rest/v2/broadcasts/{$livevideo['Livevideo']['stream_id']}/broadcast-statistics"; ?>'
            }
        };
        /* window.golive = null;


            window.golive = new Player({
                initWebRTCAdaptorAuto:false,
                path:'<?php echo Configure::read('Livevideo.livevideo_ant_media_url').'/websocket'; ?>',
                streamId:'<?php echo $livevideo['Livevideo']['stream_id']; ?>',
                accessToken: '<?php echo $this->request->query['access_token']; ?>',
                api:{
                    start_stream:'<?php echo $this->Html->url(array(
                        'plugin' => 'livevideo',
                        'controller' => 'publishing',
                        'action' => 'start_stream'
                    ),true); ?>',
                    stop_stream:'<?php echo $this->Html->url(array(
                        'plugin' => 'livevideo',
                        'controller' => 'publishing',
                        'action' => 'stop_stream'
                    ),true); ?>',
                    no_stream_exist:'<?php echo $this->Html->url(array(
                        'plugin' => 'livevideo',
                        'controller' => 'publishing',
                        'action' => 'no_stream_exist'
                    ),true); ?>',
                    get_count: '<?php echo $this->Html->url(array(
                        'plugin' => 'livevideo',
                        'controller' => 'livevideo',
                        'action' => 'count'
                    ), true); ?>'
                },
            });
         */



    </script>
<?php else: ?>

<?php endif; ?>
<?php $this->end(); ?>

<?php
$this->MooGzip->script(array('zip'=>'livevideo.player.bundle.js.gz','unzip'=>'MooApp.livevideo.player.bundle'));
?>
